#if !defined(AFX_PREVIEWDLG_H__A5F40452_4AEB_4357_8D35_6629B7CD814B__INCLUDED_)
#define AFX_PREVIEWDLG_H__A5F40452_4AEB_4357_8D35_6629B7CD814B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define PGCPREV   0		// Preview/cut PGC
#define CELLPREV  1		// Cut Cell 
#define MOTION2STILL 2  // Motion2Still
#define CELLSPLIT 3     // PREVIEWSPLIT

// PreviewDlg.h : header file
//
#include "..\DVDPreview\DVDPreview.h"

/////////////////////////////////////////////////////////////////////////////
// CPreviewDlg dialog

class CPreviewDlg : public CToolTipDialog
{
// Construction
public:
	CPreviewDlg(CWnd* pParent = NULL);   // standard constructor

	HWND		m_PreviewHWnd;
	CDVDPreview	m_VideoPreview;

	CRect m_RectDlg, m_RectPrev;

	int		m_iIFrameSel;

// Dialog Data
	//{{AFX_DATA(CPreviewDlg)
	enum { IDD = IDD_PREVIEWDLG };
	CSliderCtrl	m_CSlider;
	CComboBox	m_ComboIFrame;
	CComboBox	m_ComboCell;
	CString	m_csSector;
	CString	m_csIniSector;
	CString	m_csIniCell;
	CString	m_csEndSector;
	CString	m_csEndCell;
	int		m_iRadio;
	BOOL	m_bCheckDar;
	BOOL	m_bCheckFps;
	BOOL	m_bCheckAudio;
	CString	m_csFileStill;
	BOOL	m_bCheckChapter;
	BOOL	m_bCheckProgram;
	BOOL	m_bCheckSplit;
	//}}AFX_DATA
	int m_iDomain;
	int m_nVTS;
	int m_nT;
	int m_nCell;
	int m_nACell;
	int m_iModePrev;  // 0: PGCPREV;  1: CELLCUT: Cut cell (future) and 2:  MOTION2STILL
	int m_nCellSectors;
	__int64 m_i64IFrame;
	bool m_bIsPlaying;
	BOOL m_BEnableCut;

	int iSector,iIniSector,iIniCell,iEndSector,iEndCell,iEndIsClosed, iIniIsClosed;


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPreviewDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	virtual void EnableButtons();
	virtual void EnableButtonsSplit();
	virtual void ShowButtons();
	virtual void SendPosition( LONG wParam, bool bCheck);
	virtual void UpdateCsEdit();
	virtual void OnSize(UINT nType, int cx, int cy);
	virtual void ReSize(int cx, int cy);
	virtual void LoadMyVOB();
	virtual void LoadVOBFile(CString csVOBFile);
	virtual bool Create_mxp_file (CString csBmpFile, CString csOutputFolder, CString csProjectName);
	virtual void OnDropFiles( HDROP hDropInfo);
	virtual void OpenStillFile();


// Implementation
protected:

	HICON m_hIcon;

	virtual BOOL OnInitDialog();

	// Generated message map functions
	//{{AFX_MSG(CPreviewDlg)
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnStop();
	afx_msg void OnPlay();
	afx_msg void OnPrev();
	afx_msg void OnNext();
	afx_msg void OnInimark();
	afx_msg void OnEndmark();
	afx_msg void OnIniclear();
	afx_msg void OnEndclear();
	afx_msg void OnSelendokCombocell();
	afx_msg void OnInfo();
	afx_msg void OnCheckdar();
	afx_msg void OnCheckfps();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnButtonbmp();
	afx_msg void OnButtonfile();
	afx_msg void OnSelendokComboiframe();
	afx_msg void OnCheckprogram();
	afx_msg void OnInigoto();
	afx_msg void OnEndgoto();
	afx_msg void OnChecksplit();
	afx_msg void OnRadioCut();
	afx_msg void OnRadioKeep();
	//}}AFX_MSG
	afx_msg void OnHScroll( UINT nSBCode, UINT nPos, CScrollBar* pScrollBar );
	afx_msg void OnUser(WPARAM wParam, LPARAM lParam);
	virtual void OnMove(int x, int y) ;


	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PREVIEWDLG_H__A5F40452_4AEB_4357_8D35_6629B7CD814B__INCLUDED_)
