//  TinyPreview.cpp: included in VobBlankerDlg
//

#include "stdafx.h"
#include "sys/types.h"
#include "sys/stat.h"
//#include "io.h"
#include "ToolTipDialog.h"
#include "HtmlHelp.h"
#include "VobBlanker.h"
#include "VobBlankerDlg.h"
//#include "CreditsDlg.h"
//#include "ContactDlg.h"
//#include "PreviewDlg.h"
//#include "AAtribDlg.h"
//#include "VideoAttrDlg.h"
//#include "LogDlg.h"
//#include "CellsDlg.h"
//#include "MenusDlg.h"
//#include "SettingsDlg.h"
//#include "AnalyzeDlg.h"
//#include "FullScanDlg.h"
//#include "Tools.h"

#define TINYRATE  true
#define MINFRAMESTOPLAY   100   // 4 secs
#define MINSECTORSTOPLAY  500   // 1MB
#define MINSECTORSTOSEEK  1000  // 2MB
extern int  DurationInFrames(DWORD dwDuration);

extern CVobBlankerApp theApp;


void CVobBlankerDlg::NewPreviewSelection()
{
	int nItemT,nItemVTS;
	POSITION posT, posVTS;
	CWnd * pWnd;
	CString csTiny;
	char szFile[MAX_PATH];
	int i,n;
	struct  _stati64 statbuf;
	int m_iTinyLoaded_old;


	if (theApp.m_bInitDisTinyPrev || m_pVideoTinyPreview==NULL) return;

	nItemT=nItemVTS=-1;

	m_iTinyLoaded_old=m_iTinyLoaded;

	posT=m_CListT.GetFirstSelectedItemPosition();
	posVTS=m_CListVTS.GetFirstSelectedItemPosition();
	if (posVTS != NULL)
		nItemVTS=m_CListVTS.GetNextSelectedItem(posVTS);
	if (posT != NULL)
		nItemT=m_CListT.GetNextSelectedItem(posT);


// We cannot filter by differences in nT and nVTS,
//	because if the VTS list becomes focussed, the old values are the same
//	OLD CODE ---> if (nItemVTS!=m_iTinyPrevVTS || nItemT!=m_iTinyPrevT  )
//
	if (m_pVideoTinyPreview->IsVideoRunning ())
		OnButtonTinyStop();
// If there was a VOB already loaded  
	if (m_iTinyLoaded >=0)
	{
		SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
		ClearTinyPreview();
	}
// If there is a new Title selected different from the previous one, load it 
	if ( m_CListVTS.GetSelectedCount()> 1 ||  m_CListT.GetSelectedCount()> 1)
	{
		csTiny= "Nothing loaded";
	}
	else if (nItemVTS >0 && nItemT >=0 && !theApp.m_bInProcess )
	{
		m_iTinyPrevTotalSectors=0;
//      Beta 2 was crashing here!!!
//		i=theApp.m_dwDuration[nItemVTS][nItemT];
		m_iTinyDuration=DurationInFrames(theApp.m_dwDuration[nItemVTS][nItemT]);
		for (i=0; i<theApp.m_nCells[nItemVTS][nItemT]; i++)
		{
			n=theApp.TitleCellGetPos(nItemVTS,nItemT, i);
			if (n>=0)
				m_iTinyPrevTotalSectors+=((int)(theApp.m_TitleCells[nItemVTS][n].i64size/2048));
		}
		sprintf( szFile,"%s\\VTS_%02d_1.VOB",theApp.m_csInputPath, nItemVTS);
		if (_stati64 ( szFile, &statbuf)==0  && statbuf.st_size > 0 )
		{
			SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
			m_pVideoTinyPreview->LoadFile(szFile,true, false);
			m_pVideoTinyPreview->WaitForThread();
			m_iTinyLoaded=TITLES;
			csTiny.Format(_T("Titles PGCs Preview: VTS:%02d PGC:%02d"),nItemVTS,nItemT+1);
		}
		else
			csTiny= "Nothing loaded";
	}
// If there is a new Menu selected and focused, load it 
	else if (theApp.m_bCheckTinyMenus  && nItemVTS >=0 && nItemT <0
		      && m_bFocusVTSList && !theApp.m_bInProcess ) 
	{
// Duration is not filled in Cell array until ptocessing... so trusting in MINSECTORSTOPLAY
		m_iTinyDuration=MINFRAMESTOPLAY+1;
		m_iTinyPrevTotalSectors=0;
		for (i=0; i<theApp.m_MenuCells[nItemVTS].GetSize(); i++)
			m_iTinyPrevTotalSectors+=((int)(theApp.m_MenuCells[nItemVTS][i].i64size/2048));

		if (nItemVTS==0)
			sprintf( szFile,"%s\\VIDEO_TS.VOB",theApp.m_csInputPath, nItemVTS);
		else
			sprintf( szFile,"%s\\VTS_%02d_0.VOB",theApp.m_csInputPath, nItemVTS);
		if (_stati64 ( szFile, &statbuf)==0  && statbuf.st_size > 0 )
		{
			SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
			m_pVideoTinyPreview->LoadFile(szFile,false, false);
			m_pVideoTinyPreview->WaitForThread();
			m_iTinyLoaded=MENUS;
			if (nItemVTS ==0)
				csTiny.Format(_T("Menu full domain Preview: VIDEO_TS"));
			else
				csTiny.Format(_T("Menu full domain Preview: VTS:%02d"),nItemVTS);
		}
		else
			csTiny= "Nothing loaded";
	}
	else
		csTiny= "Nothing loaded";
	m_iTinyPrevCell=-1;
	m_iTinyPrevVTS=nItemVTS;
	m_iTinyPrevT=nItemT;

// If there is any kind of VOB  loaded  
	if ( m_iTinyLoaded >=0)
	{
		ReSizeTinyPrev(m_RectApp.Width(),m_RectApp.Height());
		m_pVideoTinyPreview->PlaybackActualRate(TINYRATE);
		pWnd=GetDlgItem(IDC_SLIDERTINYPREV);
		pWnd->EnableWindow(TRUE);
		pWnd=GetDlgItem(IDC_BUTTONPLAY);
		pWnd->EnableWindow(TRUE);
		pWnd=GetDlgItem(IDC_BUTTONSTOP);
		pWnd->EnableWindow(TRUE);
		if (theApp.m_bCheckTinyGoto10 && m_iTinyPrevTotalSectors > MINSECTORSTOSEEK)
		{
			GoToPercInPGC(100);
			m_CSliderTinyPrev.SetPos(100);
		}
		else
		{
			m_CSliderTinyPrev.SetPos(0);
			GoToPercInPGC(0);
		}
		if (theApp.m_bCheckAutoPlayTiny)
			OnButtonTinyPlay();
	}
	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
	pWnd=GetDlgItem(IDC_STATICTINYPREV);
	pWnd->SetWindowText(csTiny);
}

void CVobBlankerDlg::GoToPercInPGC(int iPos)
{
	int iSector;
	int i,n;
	int iIniSector, iEndSectorCell;
	int	nSelectedCell;


	if (theApp.m_bInitDisTinyPrev) return;

	iSector=(int)(((__int64)iPos*(__int64)m_iTinyPrevTotalSectors)/1000);

	iIniSector=0;

	if (m_iTinyLoaded==TITLES)
	{
		iEndSectorCell=iIniSector=0;
		nSelectedCell=theApp.m_nCells[m_iTinyPrevVTS][m_iTinyPrevT]-1;
		for (i=0;  i<= nSelectedCell; i++)
		{
			n=theApp.TitleCellGetPos(m_iTinyPrevVTS,m_iTinyPrevT, i);
			if (n>=0)
				iEndSectorCell+=((int)(theApp.m_TitleCells[m_iTinyPrevVTS][n].i64size/2048));
			if (iEndSectorCell>=iSector)
			{
				nSelectedCell=i;
			}
		}
		if (n>=0)
		{
			iIniSector=iSector-(iEndSectorCell-((int)(theApp.m_TitleCells[m_iTinyPrevVTS][n].i64size/2048)));
			if (iIniSector <0 ) iIniSector=0;
			iIniSector+=((int)(theApp.m_TitleCells[m_iTinyPrevVTS][n].i64IniSecCell));
		}
		m_iTinyPrevCell=nSelectedCell;
	}
	else if (m_iTinyLoaded==MENUS)
		iIniSector=iSector;


//	FILE * log;
//	log= fopen ("D:\\trace.txt","a");
//	fprintf (log, "%d %d  %d %d \n", iPos,nSelectedCell, iIniSector, m_iTinyPrevTotalSectors);
//	fclose (log);

	if (m_pVideoTinyPreview->IsVideoRunning())
		OnButtonTinyStop();

	m_pVideoTinyPreview->SetStopSector(-1);
	m_pVideoTinyPreview->WaitForThread();

	m_pVideoTinyPreview->GoToSector(iIniSector, 1);
	m_pVideoTinyPreview->WaitForThread();

}


void CVobBlankerDlg::OnButtonTinyPlay() 
{
	// TODO: Add your control notification handler code here
	int n, iDestSector;

	if (theApp.m_bInitDisTinyPrev) return;

	if ((!m_pVideoTinyPreview->IsVideoRunning() && m_iTinyLoaded >=0)
				&& (m_iTinyDuration > MINFRAMESTOPLAY ) 
				&& (m_iTinyPrevTotalSectors > MINSECTORSTOPLAY) )
	{
		SetTimer(1, 1000, 0);

		if (m_iTinyLoaded ==TITLES)
		{
			n=theApp.TitleCellGetPos(m_iTinyPrevVTS,m_iTinyPrevT, m_iTinyPrevCell);
			if (n>=0)
			{
				iDestSector=((int)(theApp.m_TitleCells[m_iTinyPrevVTS][n].i64EndSecCell));
				m_pVideoTinyPreview->SetStopSector(iDestSector);
				m_pVideoTinyPreview->WaitForThread();
			}
		}
		else
		{
			m_pVideoTinyPreview->SetStopSector(-1);
			m_pVideoTinyPreview->WaitForThread();
		}

		m_pVideoTinyPreview->PlaybackActualRate(TINYRATE);
		m_pVideoTinyPreview->Play();
	}
}

void CVobBlankerDlg::OnButtonTinyStop() 
{
	// TODO: Add your control notification handler code here

	if (theApp.m_bInitDisTinyPrev || !m_pVideoTinyPreview ) return;

	if (m_pVideoTinyPreview->IsVideoRunning())
	{
		KillTimer(1);
		m_pVideoTinyPreview->Stop();
		m_pVideoTinyPreview->WaitForThread();
	}
	m_pVideoTinyPreview->SetStopSector(-1);

}
void CVobBlankerDlg::OnHScroll( UINT nSBCode, UINT nPos, CScrollBar* pScrollBar )
{
	int iPos;
	CWnd *pWnd;
	CString csAux;

	if (theApp.m_bInitDisTinyPrev) return;

//	if (nSBCode!=TB_THUMBTRACK) return;

	pWnd=GetDlgItem(IDC_SLIDERTINYPREV);

	if (pScrollBar!=pWnd) return;

// Check if something is loaded
	if (m_iTinyLoaded<0 ) return;

	iPos=m_CSliderTinyPrev.GetPos();

	GoToPercInPGC(iPos);


}
void CVobBlankerDlg::OnMove(int x, int y) 
{
	CDialog::OnMove(x, y);

	if (theApp.m_bInitDisTinyPrev) return;

	// This is necessary, so when you move the preview window, the video moves with it!
	// Only necessary when using the video overlay mixer.
	m_pVideoTinyPreview->HandleMessage(WM_MOVE,0,0);
}


void CVobBlankerDlg::ReSizeTinyPrev(int cx, int cy) 
{

	// TODO: Add your message handler code here
	float fscale_x, fscale_y;
	int iDar,iVideoAttr;
	int iIniX,iIniY;

	CRect myRect;
	int imaxhoriz,imaxvert;
	int iResHoriz,iResVert;

	if (theApp.m_bInitDisTinyPrev) return;

	iVideoAttr=theApp.m_iVideoAttr[1];

	iDar=0;
	if ((iVideoAttr & 0x0C00) != 0)  
		iDar=1;

	iResHoriz=m_pVideoTinyPreview->GetCodedPictureWidth();
	iResVert=m_pVideoTinyPreview->GetCodedPictureHeight();

	if (iResHoriz==0 || iResVert==0) return;

	imaxhoriz=m_RectTinyPrev.Width();
	imaxvert=m_RectTinyPrev.Height();

	iIniX=m_RectTinyPrev.left;
	iIniY=m_RectTinyPrev.top;

	fscale_x=(float)imaxhoriz/(float)iResHoriz;
	fscale_y=(float)imaxvert/(float)iResVert;

	m_pVideoTinyPreview->SetVideoScaling(fscale_x,fscale_y);
//	m_pVideoTinyPreview->WaitForThread();

	::SetWindowPos(m_TinyPreviewHWnd,HWND_TOP,iIniX,iIniY,0,0,SWP_NOSIZE|SWP_NOZORDER);
	m_pVideoTinyPreview->SetVideoPosition(iIniX,iIniY);
}


void CVobBlankerDlg::OnTimer(UINT nIDEvent )
{
	if (theApp.m_bInitDisTinyPrev ||m_iTinyLoaded <0 )
	{
		KillTimer(1);	
		return;
	}

// May be the playback stopped by itself (or by user)
// Stop timer and set slider position.
	if (!m_pVideoTinyPreview->IsVideoRunning())
		KillTimer(1);	
	SetSliderPos();
}

void CVobBlankerDlg::SetSliderPos()
{
	int iCurrentTotalSectors,iCurrentSector,iSectorInCell;
	int iPos;
	int i,n;

	if (theApp.m_bInitDisTinyPrev) return;

	if (m_iTinyLoaded <0) return;

	iCurrentSector=m_pVideoTinyPreview->GetCurrentSector();

	iCurrentTotalSectors=0;
	n=0;
	iPos=0;
	if (m_iTinyLoaded==TITLES)
	{
		for (i=0;  i< m_iTinyPrevCell; i++)
		{
			n=theApp.TitleCellGetPos(m_iTinyPrevVTS,m_iTinyPrevT, i);
			if (n>=0)
				iCurrentTotalSectors+=((int)(theApp.m_TitleCells[m_iTinyPrevVTS][n].i64size/2048));
		}

		iSectorInCell=0;
		n=theApp.TitleCellGetPos(m_iTinyPrevVTS,m_iTinyPrevT, m_iTinyPrevCell);
		if (n>=0)
		{
			iSectorInCell= iCurrentSector-((int)(theApp.m_TitleCells[m_iTinyPrevVTS][n].i64IniSecCell));
			if ( iSectorInCell<0 || iSectorInCell> ((int)(theApp.m_TitleCells[m_iTinyPrevVTS][n].i64EndSecCell)) )
				iSectorInCell=0;
		}
		iPos=(int)(((__int64)(1000*(__int64)( iSectorInCell+ iCurrentTotalSectors)))/(__int64)m_iTinyPrevTotalSectors);

	}
	if (m_iTinyLoaded==MENUS)
		iPos=(int)(((__int64)(1000*(__int64)(iCurrentSector)))/(__int64)m_iTinyPrevTotalSectors);

	m_CSliderTinyPrev.SetPos(iPos);

//	FILE * log;
//	log= fopen ("D:\\trace.txt","a");
//	fprintf (log, "%d %d %d %d %d\n", iPos, m_iTinyPrevCell, iCurrentSector,iCurrentTotalSectors,iSectorInCell );
//	fclose (log);

}

void CVobBlankerDlg::OnUser(WPARAM wParam, LPARAM lParam)
{
// Here, we handle messages sent by DVD2AVI.
	int iIniSector, iEndSector;
	int n;

	if (theApp.m_bInitDisTinyPrev) return;

	if(wParam == ID_THREAD_STOPPED)
	{
	}
	else if(wParam == ID_SECTOR_HIT)
	{

//	We're here because playback hit a sector limit.
//	FILE * log;
//	int iCurrentSector;
//	iCurrentSector=m_pVideoTinyPreview->GetCurrentSector();
//	log= fopen ("D:\\trace.txt","a");
//	fprintf (log, "%d %d\n", m_iTinyPrevCell, iCurrentSector );
//	fclose (log);

		KillTimer(1);
// This never should happen in Menus....
		if (m_iTinyLoaded == MENUS) 
		{
			m_CSliderTinyPrev.SetPos(1000);
			return;
		}

		if (m_iTinyPrevCell+1 < theApp.m_nCells[m_iTinyPrevVTS][m_iTinyPrevT] )
		{
			m_iTinyPrevCell++;
			n=theApp.TitleCellGetPos(m_iTinyPrevVTS,m_iTinyPrevT, m_iTinyPrevCell);
			if (n>=0)
			{
				iIniSector= ((int)(theApp.m_TitleCells[m_iTinyPrevVTS][n].i64IniSecCell));
				m_pVideoTinyPreview->GoToSector(iIniSector, 1);
				m_pVideoTinyPreview->WaitForThread();

				iEndSector= ((int)(theApp.m_TitleCells[m_iTinyPrevVTS][n].i64EndSecCell));
				m_pVideoTinyPreview->SetStopSector(iEndSector);
				m_pVideoTinyPreview->WaitForThread();

				SetTimer(1, 1000, 0);

				m_pVideoTinyPreview->PlaybackActualRate(TINYRATE);
				m_pVideoTinyPreview->Play();
			}
			else
			{
				SetSliderPos();
			}
		}
		else
			m_CSliderTinyPrev.SetPos(1000);
//	log= fopen ("D:\\trace.txt","a");
//	fprintf (log, "---%d %d %d\n", m_iTinyPrevCell, iIniSector, iEndSector );
//	fclose (log);
	}
}

void CVobBlankerDlg::DestroyTinyPreview()
{
	CWnd * pWnd;

	if (theApp.m_bInitDisTinyPrev) return;

	m_iTinyLoaded=-1; // Do it as soon as possible. May be a timer message is coming..

	if (m_pVideoTinyPreview)
	{
		OnButtonTinyStop();
/*		if (m_pVideoTinyPreview->IsVideoRunning ())
		{
			m_pVideoTinyPreview->Stop();
			m_pVideoTinyPreview->WaitForThread();
			m_pVideoTinyPreview->SetStopSector(-1);
		}
*/
		if (m_iTinyPrevVTS >0 && m_iTinyPrevT >=0)
			m_pVideoTinyPreview->CloseFile();

		m_pVideoTinyPreview->QuickRelease();

		m_pVideoTinyPreview->DestroyPreview(m_TinyPreviewHWnd);

		delete m_pVideoTinyPreview;
		m_pVideoTinyPreview=NULL;
	}

	m_iTinyPrevVTS=m_iTinyPrevT=-1;

	pWnd=GetDlgItem(IDC_SLIDERTINYPREV);
	pWnd->EnableWindow(FALSE);
	pWnd=GetDlgItem(IDC_BUTTONPLAY);
	pWnd->EnableWindow(FALSE);
	pWnd=GetDlgItem(IDC_BUTTONSTOP);
	pWnd->EnableWindow(FALSE);

	m_CSliderTinyPrev.SetPos(0);
}

void CVobBlankerDlg::CreateTinyPreview()
{
	CWnd * pWnd;

	m_iTinyLoaded=-1;
	if (theApp.m_bInitDisTinyPrev) return;

	pWnd=GetDlgItem(IDC_BUTTONPLAY);
	pWnd->EnableWindow(FALSE);
	pWnd=GetDlgItem(IDC_BUTTONSTOP);
	pWnd->EnableWindow(FALSE);
	pWnd=GetDlgItem(IDC_SLIDERTINYPREV);
	pWnd->EnableWindow(FALSE);

	m_pVideoTinyPreview= new CDVDPreview;

	m_TinyPreviewHWnd = m_pVideoTinyPreview->InitPreview(m_hWnd,.5,.5,m_RectTinyPrev.left,m_RectTinyPrev.top,
		SW_SHOW,true,WS_CHILD, theApp.m_bCheckNoOverlay);
	ReSizeTinyPrev(m_RectApp.Width(),m_RectApp.Height());

}



void CVobBlankerDlg::ClearTinyPreview()
{
	CWnd * pWnd;

// If there was a VOB already loaded, close the files 
	if (theApp.m_bInitDisTinyPrev) return;

	if (m_iTinyLoaded >=0)
	{
/*		if (m_pVideoTinyPreview->IsVideoRunning ())
		{
			m_pVideoTinyPreview->Stop();
			m_pVideoTinyPreview->WaitForThread();
		}
*/
		OnButtonTinyStop();
		m_pVideoTinyPreview->SetStopSector(-1);

		m_iTinyLoaded=-1;
		m_pVideoTinyPreview->CloseFile();

// clean the video window
		m_pVideoTinyPreview->EraseVideoFrame();
		m_pVideoTinyPreview->WaitForThread();
		m_pVideoTinyPreview->LoadFile("",false,true);

		pWnd=GetDlgItem(IDC_SLIDERTINYPREV);
		pWnd->EnableWindow(FALSE);
		m_CSliderTinyPrev.SetPos(0);
		pWnd=GetDlgItem(IDC_BUTTONPLAY);
		pWnd->EnableWindow(FALSE);
		pWnd=GetDlgItem(IDC_BUTTONSTOP);
		pWnd->EnableWindow(FALSE);
	}
	pWnd=GetDlgItem(IDC_STATICTINYPREV);
	pWnd->SetWindowText("Nothing loaded");

	m_iTinyPrevVTS=-1;
	m_iTinyPrevT=-1;
}
