// VobBlanker.cpp : Defines the class behaviors for the application.
//
// Titles Processing Part


#include "stdafx.h"
#include "direct.h"
#include "sys/types.h"
#include "sys/stat.h"
#include "io.h"
#include "Winbase.h"
#include "ToolTipDialog.h"
#include "VobBlanker.h"
#include "VobBlankerDlg.h"
#include "LogDlg.h"
#include "InfoDlg.h"
#include "CellsDlg.h"
#include "Externs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//////////////////////////////////////////////////////////////////////
////////          Main processing method          ////////////////////
//////////////////////////////////////////////////////////////////////

void CVobBlankerApp::ProcessVob(int nVTS, CWnd* pDlg)
{

	__int64 i64size;
	int k;
	CString csAuxIn,csAux;
//	struct  _stati64 statbuf;
	int nCells;
	int nLastRefCell;
	bool bRef,bAlreadyKept;
	int iCID,iVID, iVID_old;
	int nDeleted;

	FILE *log;

	m_ANavinfo.RemoveAll();
	for (k=0;k<8;k++)
		m_AAudioinfo[k].RemoveAll();
	for (k=0;k<32;k++)
		m_ASubsinfo[k].RemoveAll();

	m_Fin=m_Fout=NULL;
	i64size=0;
/*	for (k=1; k<10; k++)
	{
		csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS,k);
		csAuxIn=m_csInputPath+'\\'+csAux;
		if (_stati64 ( csAuxIn, &statbuf)==0)
		{
			m_i64VOBsize[nVTS][k]= statbuf.st_size;
			i64size+=m_i64VOBsize[nVTS][k];
		}
		else k=20;
	}
*/
// Prepare SimpleVob
	FillSimpleVob(SimpleVob,m_iVideoAttr[nVTS]);

	if (((m_iVideoAttr[nVTS] & 0x1000)>>12) == PAL ) m_ticsperframe=3600;
	else m_ticsperframe=3003;

// Calculate Total number of packs.
	m_i64OutputLBA=0;
	m_i64TotalLBA=0;
	for (k=0; k<m_nPGCs[nVTS];k++)
	{
		m_iFixDuration=0;
		if (m_iAction[nVTS][k]==KEEP )          m_i64TotalLBA+=(m_i64Tisize[nVTS][k]/2048);
		else if (m_iAction[nVTS][k]==BLANK   )  m_i64TotalLBA+=(m_nCells[nVTS][k]*5);
		else if (m_iAction[nVTS][k]==REPLACE )  m_i64TotalLBA+=m_i64Rsize[nVTS][k]/2048;
		else if (m_iAction[nVTS][k]==STRIP   )  m_i64TotalLBA+=m_i64Rsize[nVTS][k]/2048;
		else if (m_iAction[nVTS][k]==CUT     )  m_i64TotalLBA+=m_i64Rsize[nVTS][k]/2048;
		else if (m_iAction[nVTS][k]==CELLBASED) m_i64TotalLBA+=m_i64Rsize[nVTS][k]/2048;
	}
	if( m_i64TotalLBA==0) m_i64TotalLBA=1;

	m_nVobout=1;
	csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobout);
	m_csFout=m_csOutputPath+ '\\' +csAux;
	m_Fout=fopen(m_csFout,"wb");

// Reset temporary buffer counter
	m_nPackstobeWritten=0;

	csAux.Format(_T("VTS %02d: Processing VOB (Titles)"),nVTS);
	MyLog(csAux);

	m_bFixVobs=false;
///////////////////////////////////////////////////////////////////////////
///             FIRST PHASE: LOOP INTO PGCS AND PREPARE CELLS  ////////////
///////////////////////////////////////////////////////////////////////////
	MyLog("--------------TITLE VOB PREPARING PHASE-",GREEN15);

	nCells=m_TitleCells[nVTS].GetSize();

	for (k=0 ; k<nCells; k++)
	{
		m_TitleCells[nVTS][k].iMode=UNREF;
		m_TitleCells[nVTS][k].bFixPointers=false;
		m_TitleCells[nVTS][k].bToBeDeleted=false;
	}

////////////////////////////////////////////////////////
// Fill with unreferenced cells the holes in the sequence
	if (m_bCheckVobFill) FillTitleVobHoles(nVTS);

	k=nCells;
	nCells=m_TitleCells[nVTS].GetSize();
	m_i64TotalLBA+=((nCells-k)*5);

	m_nVOBIDsInProcess = m_nTMaxVOBIDs[nVTS];

	for (k=0; k<m_nPGCs[nVTS] && m_bInProcess==true;k++)
	{
		if (m_iAction[nVTS][k]==KEEP )				TitleKeep(nVTS,k);
		else if (m_iAction[nVTS][k]==STRIP )		TitleStrip(nVTS,k);
		else if (m_iAction[nVTS][k]==BLANK)			TitleBlank(nVTS,k);
		else if (m_iAction[nVTS][k]==REPLACE)		TitleReplace(nVTS,k);
		else if (m_iAction[nVTS][k]==CUT)			TitleCut(nVTS,k);
		else if (m_iAction[nVTS][k]==CELLBASED)		TitleBasedCell(nVTS,k);
	}	

///////////////////////////////////////////////////////////////////////////
/// Deletion of unreferenced cells in the middle of the VOB
	nCells=m_TitleCells[nVTS].GetSize();
	for (k=0 ; k<nCells; k++)
		m_TitleCells[nVTS][k].bToBeDeleted=false;

	nLastRefCell=0;
	for (k=0; k<nCells; k++)
		if (m_TitleCells[nVTS][k].iMode!=UNREF ) nLastRefCell=k;


	nDeleted=0;
	if (!m_bCheckVobMUnref)
	{
		for (k=(nLastRefCell-1); k>=0; k--)
		{
			if (m_TitleCells[nVTS][k].iMode==UNREF)
			{
				m_TitleCells[nVTS][k].bToBeDeleted=true;
				nDeleted++;
			}
		}
	}
	if (nDeleted)
	{
		m_i64TotalLBA-=(nDeleted*5);
		csAux.Format(_T("%d"),nDeleted);
		MyLog("     NOTE: Deleted " + csAux + " unreferenced cells (in the middle of the VOB)" ,CIAN15 );
		m_nNotes++;
	}
	if( m_i64TotalLBA<=0) m_i64TotalLBA=1;


///////////////////////////////////////////////////////////////////////////
/// Deletion of unreferenced cells at the last part of each VOB-ID

	nCells=m_TitleCells[nVTS].GetSize();
	nDeleted=0;
	if (!m_bCheckVobLUnref)
	{
		for (k=(nCells-1), iVID_old=-1,bRef=bAlreadyKept=false; k>=0 ; k--)
		{
			if (m_TitleCells[nVTS][k].bToBeDeleted==false)
			{
				iVID=m_TitleCells[nVTS][k].VID;
				iCID=m_TitleCells[nVTS][k].CID;
				if (iVID != iVID_old) bRef=false;
				iVID_old=iVID;

				if (m_TitleCells[nVTS][k].iMode==UNREF && bRef==false && 
					(iCID!=1 || bAlreadyKept==false))
				{
					m_TitleCells[nVTS][k].bToBeDeleted=true;
					nDeleted++;
				}
				else bRef=bAlreadyKept=true;
			}
		}
	}
	if (nDeleted)
	{
		m_i64TotalLBA-=(nDeleted*5);
		csAux.Format(_T("%d"),nDeleted);
		MyLog("     NOTE: Deleted " + csAux + " unreferenced cells (the last ones of the VOB-IDs)" ,CIAN15 );
		m_nNotes++;
	}
	if( m_i64TotalLBA<=0) m_i64TotalLBA=1;

////////////////////////////////////////////
// Renumber VCIDs in final VOB. 
	FillTitleOutputVCIDs(nVTS);
	
///////////////////////////////////////////////////////////////////////////
///             SECOND PHASE: WRITE THE VOB ///////////////////////////////
///////////////////////////////////////////////////////////////////////////
	MyLog("--------------TITLE VOB WRITING PHASE STARTED-",GREEN15);

	nCells=m_TitleCells[nVTS].GetSize();
	m_nVOBIDsInProcess = m_nTMaxVOBIDs[nVTS];
	m_bFixVobs=false;
	for (k=0;k<nCells && m_bInProcess==true;k++)
	{
		m_iFixDuration=0;
		if (m_TitleCells[nVTS][k].iMode==KEEP )				TitleCellKeep(nVTS,k,pDlg);
		else if (m_TitleCells[nVTS][k].iMode==STRIP )		TitleCellStrip(nVTS,k,pDlg);
		else if (m_TitleCells[nVTS][k].iMode==BLANK)		TitleCellBlank(nVTS,k,pDlg);
		else if (m_TitleCells[nVTS][k].iMode==REPLACE)		TitleCellReplace(nVTS,k,pDlg);
		else if (m_TitleCells[nVTS][k].iMode==CUT)			TitleCellCut(nVTS,k,pDlg);
		else if (m_TitleCells[nVTS][k].iMode==CELLBASED)	TitleCellBasedCell(nVTS,k,pDlg);
		else if (m_TitleCells[nVTS][k].iMode==UNREF && 
				 m_TitleCells[nVTS][k].bToBeDeleted==false) TitleCellUnref(nVTS,k,pDlg);

		if (m_TitleCells[nVTS][k].bFixPointers ==true) m_bFixVobs=true;
	}

	if (m_BUseHDDBuffer != 0)
	{
		FlushMegaBuffer(m_MegaBuffer,m_nPackstobeWritten, m_Fout);
		m_nPackstobeWritten=0;
	}
	if (m_Fout!=NULL) fclose(m_Fout);
	if (m_Fin !=NULL) fclose(m_Fin);
	m_Fin=m_Fout=NULL;

	if ( m_bInProcess!=true ) return;

	MyLog("--------------TITLE VOB WRITING FINISHED-",GREEN15);

	FillTitleCellInfo(nVTS);

	csAux.Format(_T("VTS %02d: Cell data array filled (Titles)"),nVTS);
	MyLog(csAux);

///////////////////////////////////////////////////////////////////////////
///             DEBUGING: LOG SOME INFO     ///////////////////////////////
///////////////////////////////////////////////////////////////////////////

	if (LOGNAV && m_bLog)
	{
		csAux.Format(_T("C:\\navinfo_%02d_log.txt"),nVTS);

		log=fopen(csAux,"w");
		fprintf (log,"#     LBA     LastLBA   VID/CID Duration Frames   PTS0   PST1\n");
		for (k=0;k<m_ANavinfo.GetSize();k++)
		{
			csAux.Format(_T("%04d %08I64X %08I64X--->%02d %02d %08X %08d %08d %8d"), k,
				m_ANavinfo[k].LBA,m_ANavinfo[k].LastLBA,
				m_ANavinfo[k].VID,m_ANavinfo[k].CID,
				m_ANavinfo[k].dwDuration, m_ANavinfo[k].frames,
				m_ANavinfo[k].iPTS0, m_ANavinfo[k].iPTS1 );
			fprintf (log,"%s\n",csAux);
		}
		fclose(log);
	}
}

void CVobBlankerApp::FillTitleOutputVCIDs(int nVTS)
{
	int nC,nCells;
	int nV,nVIDs;
	int NCID,NVID;
	bool bVIDExists;
	int nSplitCID;

	nVIDs=GetTitleMaxVobId(nVTS);

	nCells=m_TitleCells[nVTS].GetSize();

///////////////////////////////////////////////////////////
// 1st: (Always needed) Fill the New VCID with the old ones.
	for (nC=0;nC<nCells;nC++)
	{
		m_TitleCells[nVTS][nC].NVID = m_TitleCells[nVTS][nC].VID;
		m_TitleCells[nVTS][nC].NCID = m_TitleCells[nVTS][nC].CID;
	}

//////////////////////////////////////////////////////////////////7
// 2nd: Renumber VCIDs with the lowest ones (if checked)
// Loop over all the VIDs. For each VID, loop over all the Cells
// For each Cell, change VID to the first unused and change CID with the first unused
	if (m_bCheckVobRenumber)
	{
		NVID=1;
		for (nV=1;nV<=nVIDs; nV++)
		{
			NCID=1;
			bVIDExists=false;
			for (nC=0;nC<nCells;nC++)
			{
				if (m_TitleCells[nVTS][nC].bToBeDeleted == false &&
					m_TitleCells[nVTS][nC].VID == nV)
				{
					bVIDExists=true;
					m_TitleCells[nVTS][nC].NVID = NVID ;
					m_TitleCells[nVTS][nC].NCID = NCID ;
					NCID++;
				}
			}
			if (bVIDExists) NVID++;
		}
	}
///////////////////////////////////////////////////////////////
// 3rd: Renumber CIDs if CELLBASED and SPLIT CELL
// Loop over all the VIDs. For each VID, loop over all the Cells
// if m_bCheckVobRenumber NOT NEEDED: This has been done in step 2
	if (!m_bCheckVobRenumber)
	{
		for (nV=1;nV<=nVIDs; nV++)
		{
			nSplitCID=0;
			for (nC=0;nC<nCells;nC++)
			{
				if (m_TitleCells[nVTS][nC].bToBeDeleted == false &&
					m_TitleCells[nVTS][nC].VID == nV)
				{
					m_TitleCells[nVTS][nC].NCID+=nSplitCID ;
					if (m_TitleCells[nVTS][nC].iMode==CELLBASED &&
						(m_TitleCells[nVTS][nC].chMode=='P' ||(m_TitleCells[nVTS][nC].chMode=='C' && m_TitleCells[nVTS][nC].iCutMode >=CUT4S))	&&
						m_TitleCells[nVTS][nC].iPart==0           )
						nSplitCID++;
				}
			}
		}
	}
}

int CVobBlankerApp::FillTitleVobHoles(int nVTS)
{
// returns the number of cells inserted.
	int n,nCells,nInserted;
	int VID,CID;
	TITLE_CELL_LIST myCell;
	int VidOld,CidOld;
	int i;


	nInserted=0;
	VidOld=0; CidOld=1;

	nCells=m_TitleCells[nVTS].GetSize();
	for (n=0;n<nCells;n++)
	{
		VID=m_TitleCells[nVTS][n].VID;
		CID=m_TitleCells[nVTS][n].CID;
		if (VID > (VidOld+1))
		{
			for (i=0; i<(VID-VidOld-1);i++)
			{
				myCell.VID=VidOld+1+i;
				myCell.CID=1;
				myCell.iPart=0;
				myCell.iMode=UNREF;
				myCell.nT=-1;
				m_TitleCells[nVTS].InsertAt(n+i,myCell);
				nInserted++;
			}
		}
		else if (VID ==(VidOld+1))
		{
			if (CID!=1)
			{
				for (i=0; i<(CID-1);i++)
				{
					myCell.VID=VID;
					myCell.CID=i+1;
					myCell.iPart=0;
					myCell.iMode=UNREF;
					myCell.nT=-1;
					m_TitleCells[nVTS].InsertAt(n+i,myCell);
					nInserted++;
				}
			}
		}
		else if (VID ==VidOld)
		{
			if (CID >(CidOld+1))
			{
				for (i=0; i<(CID-CidOld-1);i++)
				{
					myCell.VID=VID;
					myCell.CID=CidOld+i+1;
					myCell.iPart=0;
					myCell.iMode=UNREF;
					myCell.nT=-1;
					m_TitleCells[nVTS].InsertAt(n+i,myCell);
					nInserted++;
				}
			}
		}
//		else ... VID/CID goes backwards.. Something was wrong, Unexpected..
		VidOld=VID;
		CidOld=CID;
	}
	return nInserted;
}
///////////////////////////////////////////////////////////////////////////
///             PGC Methods, called in First phase     ////////////////////
///////////////////////////////////////////////////////////////////////////

void CVobBlankerApp::TitleBlank(int nVTS,int nT)
{
	int n,nCell;
	CString csAux;

	csAux.Format(_T("VTS %02d: Blanking PGC %02d"),nVTS,nT+1);
	MyLog(csAux);

	for (nCell=0; nCell<m_nCells[nVTS][nT] ;nCell++)
	{
		n=TitleCellGetPos( nVTS, nT, nCell);
		if (n <0) 
		{
			MyErrorLog_Box("Error: Cell not found");
			m_bInProcess=false;
			return;
		}
		if (m_TitleCells[nVTS][n].iMode==UNREF)
		{
			m_TitleCells[nVTS][n].iMode=BLANK;
			m_TitleCells[nVTS][n].nT=nT;
			m_TitleCells[nVTS][n].bFixPointers=false;
		}
	}
}

void CVobBlankerApp::TitleKeep(int nVTS,int nT)
{
	int n,nCell;
	CString csAux;

	csAux.Format(_T("VTS %02d: Keeping PGC %02d"),nVTS,nT+1);
	MyLog(csAux);

	for (nCell=0; nCell<m_nCells[nVTS][nT] ;nCell++)
	{
		n=TitleCellGetPos( nVTS, nT, nCell);
		if (n <0) 
		{
			MyErrorLog_Box("Error: Cell not found");
			m_bInProcess=false;
			return;
		}
		if (m_TitleCells[nVTS][n].iMode==UNREF)
		{
			m_TitleCells[nVTS][n].iMode=KEEP;
			m_TitleCells[nVTS][n].nT=nT;
			m_TitleCells[nVTS][n].bFixPointers=false;
		}
// Mark Cell with FV_FixVobPointers if required
// Check ILV flag
		if (m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell] & 0x04 )
			m_TitleCells[nVTS][n].bFixPointers=true;
	}
}


void CVobBlankerApp::TitleBasedCell(int nVTS,int nT)
{
	int n, nCell, nACell;
	CString csAux;
	bool bAlready;
	TITLE_CELL_LIST myCell;
	int CellId,VobId;
	int i;
	__int64 i64IFrame;
	int indexReplace;
	int iSplitMode;
	__int64 i64IniSec, i64EndSec;
	int iIniSector, iEndSector, iIniIsClosed, iEndIsClosed, iAction;



	csAux.Format(_T("VTS %02d: Cell Based PGC %02d"),nVTS,nT+1);
    MyLog(csAux);

	//  Loop cell by cell 
	for (nCell=0; nCell<m_nCells[nVTS][nT] ;nCell++)
	{
		n=TitleCellGetPos( nVTS, nT, nCell);
		if (n <0) 
		{
			MyErrorLog_Box("Error: Cell not found");
			m_bInProcess=false;
			return;
		}
		if (m_TitleCells[nVTS][n].iMode==UNREF)
		{
			bAlready=false;
			m_TitleCells[nVTS][n].iMode=CELLBASED;
			m_TitleCells[nVTS][n].nT=nT;
			m_TitleCells[nVTS][n].bFixPointers=false;
		}
		else bAlready=true;

		VobId =m_TitleCells[nVTS][n].VID;
		CellId=m_TitleCells[nVTS][n].CID;

		switch (m_csCellBased[nVTS][nT][nCell])
		{
		case 'R':
			for (i=0,indexReplace=-1; i< m_ACell_replace.GetSize() && indexReplace==-1; i++)
			{
				if (m_ACell_replace[i].nT==nT && 
					m_ACell_replace[i].nCell==nCell &&
					m_ACell_replace[i].nVTS==nVTS &&
					m_ACell_replace[i].iDomain==TITLES)
					indexReplace=i;
			}
			if (bAlready)
			{
				m_nVOBIDsInProcess++;
				myCell.CID=1;
				myCell.iPart=0;
				myCell.VID=m_nVOBIDsInProcess;
				n=m_TitleCells[nVTS].GetSize();
				m_TitleCells[nVTS].SetAtGrow(n,myCell);
				csAux.Format(_T("     Replacing Cell # %d, VID/CID=%02d/%02d-->%02d/%02d"),nCell+1,VobId,CellId,m_nVOBIDsInProcess,1);
			}
			else
				csAux.Format(_T("     Replacing Cell # %d, VID/CID=%02d/%02d"),nCell+1,VobId,CellId);

			if (indexReplace <0)
			{
				csAux.Format(_T("     Warning: Replacing Cell not Found  # %d, VID/CID=%02d/%02d. Keeping the original one"),nCell+1,VobId,CellId);
				MyLog(csAux,ORANGE);
				m_nWarnings++;
				if (!bAlready)
				{
					m_TitleCells[nVTS][n].iMode=CELLBASED;
					m_TitleCells[nVTS][n].chMode='K';
				}
			}
			else
			{
				MyLog(csAux);
				m_TitleCells[nVTS][n].indexReplace=indexReplace;
				m_TitleCells[nVTS][n].iMode=CELLBASED;
				m_TitleCells[nVTS][n].chMode='R';
			}
			m_TitleCells[nVTS][n].bFixPointers=false;
			break;
		case 'B':
			if (bAlready)
			{
				m_nVOBIDsInProcess++;
				myCell.CID=1;
				myCell.iPart=0;
				myCell.VID=m_nVOBIDsInProcess;
				n=m_TitleCells[nVTS].GetSize();
				m_TitleCells[nVTS].SetAtGrow(n,myCell);
				csAux.Format(_T("     Blanking Cell # %d, VID/CID=%02d/%02d-->%02d/%02d"),nCell+1,VobId,CellId,m_nVOBIDsInProcess,1);
			}
			else
				csAux.Format(_T("     Blanking Cell # %d, VID/CID=%02d/%02d"),nCell+1,VobId,CellId);

			MyLog(csAux);
			m_TitleCells[nVTS][n].iMode=CELLBASED;
			m_TitleCells[nVTS][n].chMode='B';
			m_TitleCells[nVTS][n].bFixPointers=false;
			break;
		case 'S':
			if (bAlready)
			{
				csAux.Format(_T("     Skiping already processed cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);
			}
			else
			{
				csAux.Format(_T("     Motion to still+audio Cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);

				TitleCellExplore(nVTS, n);

				m_TitleCells[nVTS][n].iMode=CELLBASED;
				m_TitleCells[nVTS][n].chMode='S';
				m_TitleCells[nVTS][n].bFixPointers=false;
				for (i=0, i64IFrame=-7; i< m_ACellStillinfo.GetSize() && i64IFrame ==-7; i++)
				{
					if (m_ACellStillinfo[i].nT==nT && 
						m_ACellStillinfo[i].nCell==nCell &&
						m_ACellStillinfo[i].iDomain==TITLES &&
						m_ACellStillinfo[i].nVTS==nVTS)
					{
						i64IFrame=m_ACellStillinfo[i].i64IFrame;
						m_TitleCells[nVTS][n].indexStill=i;
					}
				}
				if (i64IFrame==-7) i64IFrame=-5;
				m_TitleCells[nVTS][n].i64IFrame1=i64IFrame;
			}
			break;
		case 'P':
			if (bAlready)
			{
				csAux.Format(_T("     Skiping already processed cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);
			}
			else
			{
				csAux.Format(_T("     Splitting Cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);

				m_TitleCells[nVTS][n].iMode=CELLBASED;
				m_TitleCells[nVTS][n].chMode='P';
				m_TitleCells[nVTS][n].bFixPointers=true;
			
				for (i=0, i64IFrame=-1; i< m_ACellSplitinfo.GetSize() && i64IFrame ==-1; i++)
				{
					if (m_ACellSplitinfo[i].nT==nT && 
						m_ACellSplitinfo[i].nCell==nCell &&
						m_ACellSplitinfo[i].iDomain==TITLES &&
						m_ACellSplitinfo[i].nVTS==nVTS)
					{
						i64IFrame=m_ACellSplitinfo[i].i64IFrame;
						iSplitMode=m_ACellSplitinfo[i].iSplitMode;
						iIniIsClosed=m_ACellSplitinfo[i].iIniIsClosed;
					}
				}
				if (i64IFrame<0) i64IFrame=0;
				m_TitleCells[nVTS][n].i64IFrame1=i64IFrame;
				m_TitleCells[nVTS][n].i64IFrame2=i64IFrame;
				if (iSplitMode<0) iSplitMode=0;
				if (iSplitMode>2) iSplitMode=0;
				m_TitleCells[nVTS][n].iSplitMode=iSplitMode;
				if (iIniIsClosed<0 || iIniIsClosed>3) iIniIsClosed=3;
				m_TitleCells[nVTS][n].iFirstIsClosedGOP=iIniIsClosed;

// Clone the Cell
				m_TitleCells[nVTS].InsertAt(n,m_TitleCells[nVTS][n]); 

// Mark 1st and 2nd part of the cell
				m_TitleCells[nVTS][n].iPart=0;
				m_TitleCells[nVTS][n+1].iPart=1;
			}
			break;

		case 'C':
			if (bAlready)
			{
				csAux.Format(_T("     Skiping already processed cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);
			}
			else
			{
				csAux.Format(_T("     Cutting Cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);
				m_TitleCells[nVTS][n].iMode=CELLBASED;
				m_TitleCells[nVTS][n].chMode='C';
				m_TitleCells[nVTS][n].bFixPointers=true;

				i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
				i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
				iIniSector=0;
				iEndSector=(int)(i64EndSec-i64IniSec);
				iIniIsClosed=iEndIsClosed=1;
				iAction=0;

				nACell=0;
				for(i=0; i< m_ACellCutinfo.GetSize(); i++)
				{
					if ( m_ACellCutinfo[i].nT== nT &&
					     m_ACellCutinfo[i].nCell== nCell &&
						 m_ACellCutinfo[i].nVTS== nVTS &&
						 m_ACellCutinfo[i].iDomain==TITLES )
					{
						if (m_ACellCutinfo[i].iEndSector>0)
							iEndSector=m_ACellCutinfo[i].iEndSector;
						if (m_ACellCutinfo[i].iIniSector>0)
							iIniSector=m_ACellCutinfo[i].iIniSector;
						iIniIsClosed=m_ACellCutinfo[i].iIniIsClosed;
						iEndIsClosed=m_ACellCutinfo[i].iEndIsClosed;
						iAction=m_ACellCutinfo[i].iAction;

						nACell=i;
					}
				}
				if (iIniSector==0 &&
				    iEndSector==(int)(i64EndSec-i64IniSec)  && iAction==0 )
				{
					// Keep Completely
					// Keep the Cell as it is
					m_TitleCells[nVTS][n].iMode=CELLBASED;
					m_TitleCells[nVTS][n].chMode='K';
					m_TitleCells[nVTS][n].bFixPointers=false;
				}
/*				else if (iIniSecCell< iEndSecCell)
				{
					// Blank the Cell 
					m_TitleCells[nVTS][n].iMode=CELLBASED;
					m_TitleCells[nVTS][n].chMode='B';
					m_TitleCells[nVTS][n].bFixPointers=false;
				}
*/
				else if (iEndSector==(int)(i64EndSec-i64IniSec) && iAction==0)
				{	//					 _______________________
					// CASE 1:			|			|			|
					//					|	DELETE	|	KEEP	|
					//					|___________|___________|

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64IniSec+=iIniSector;
					i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64EndSec < i64IniSec) i64IniSec=i64EndSec;
					m_TitleCells[nVTS][n].iFirstIsClosedGOP=iIniIsClosed;
					m_TitleCells[nVTS][n].iCutMode=CUT1;
				}
				else if (iIniSector==0 && iAction==0)
				{	//		 			 _______________________
					// CASE 2:			|			|			|
					//					|	KEEP	|	DELETE	|
					//					|___________|___________|

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec=i64IniSec+iEndSector-1;
					if ( i64EndSec > GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]))
						i64EndSec = GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64IniSec > i64EndSec) i64EndSec=i64IniSec;
					m_TitleCells[nVTS][n].iFirstIsClosedGOP=1; // First VOBU of cell, must be closed
					m_TitleCells[nVTS][n].iCutMode=CUT2;
				}
				else if (iEndSector==(int)(i64EndSec-i64IniSec) && iAction!=0)
				{	//		 			 _______________________
					// CASE 2b:			|			|			|
					//					|	KEEP	|	DELETE	|
					//					|___________|___________|

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec=i64IniSec+iIniSector-1;
					if (i64EndSec > GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]))
					   i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64IniSec > i64EndSec) i64EndSec=i64IniSec;
					m_TitleCells[nVTS][n].iFirstIsClosedGOP=1; // First VOBU of cell
					m_TitleCells[nVTS][n].iCutMode=CUT2;
				}
				else if (iIniSector==0 && iAction!=0)
				{	//		 			 _______________________
					// CASE 1b:			|			|			|
					//					|	DELETE	|	KEEP	|
					//					|___________|___________|

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64IniSec+=iEndSector;
					i64EndSec = GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64EndSec < i64IniSec) i64IniSec=i64EndSec;
					m_TitleCells[nVTS][n].iFirstIsClosedGOP=iEndIsClosed; 
					m_TitleCells[nVTS][n].iCutMode=CUT1;
				}
				
				else if (iAction==0)
				{	//					____________________________________
					// CASE 3:			|			|			|			|
					//					|	DELETE	|	KEEP	|	DELETE	|
					//					|___________|___________|___________|

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec= i64IniSec+iEndSector-1;
					i64IniSec+=iIniSector;
					if ( i64EndSec > GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]))
						i64EndSec = GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64EndSec < i64IniSec) i64IniSec=i64EndSec;
					m_TitleCells[nVTS][n].iFirstIsClosedGOP=iIniIsClosed; 
					m_TitleCells[nVTS][n].iCutMode=CUT3;
				}

				else if (iAction!=0)
				{	//					____________________________________
					// CASE 4:			|			|			|			|
					//					|	KEEP	|	DELETE	|	KEEP	|
					//					|___________|___________|___________|

					// mark Endsector as iniLBa and inisector as endlba.
					// So i64EndSec will be lower than i64IniSec.

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec= i64IniSec+iIniSector-1;

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64IniSec= i64IniSec+iEndSector;
					m_TitleCells[nVTS][n].iFirstIsClosedGOP=iEndIsClosed; 
					m_TitleCells[nVTS][n].iCutMode=CUT4;
					if ( m_ACellCutinfo[nACell].iCut4Mode > CUT4 )
					{
			// Special case. Split the cell into two cells
						m_TitleCells[nVTS][n].iCutMode=m_ACellCutinfo[nACell].iCut4Mode ;
						csAux.Format(_T("             Will be processed in split mode."));
						MyLog(csAux);
						m_TitleCells[nVTS][n].iMode=CELLBASED;
						m_TitleCells[nVTS][n].chMode='C';
						m_TitleCells[nVTS][n].bFixPointers=true;

						m_TitleCells[nVTS][n].i64IFrame1=iIniSector;
						m_TitleCells[nVTS][n].i64IFrame2=iEndSector;
						iSplitMode=0;
						if (m_ACellCutinfo[nACell].iCut4Mode == CUT4SP ) iSplitMode=1;
						if (m_ACellCutinfo[nACell].iCut4Mode == CUT4SC ) iSplitMode=2;
						m_TitleCells[nVTS][n].iSplitMode=iSplitMode;
						if (iEndIsClosed<0 || iEndIsClosed>3) iEndIsClosed=3;
						m_TitleCells[nVTS][n].iFirstIsClosedGOP=iEndIsClosed;
// Clone the Cell
						m_TitleCells[nVTS].InsertAt(n,m_TitleCells[nVTS][n]); 
// Mark 1st and 2nd part of the cell
						m_TitleCells[nVTS][n].iPart=0;
						m_TitleCells[nVTS][n+1].iPart=1;

					}
				}
				m_TitleCells[nVTS][n].i64IniSecAux=i64IniSec;
				m_TitleCells[nVTS][n].i64EndSecAux=i64EndSec;
			} // else process cell
			break;

		case 'K':
		default:
			if (bAlready)
			{
				csAux.Format(_T("     Skiping already processed cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);
			}
			else
			{
				csAux.Format(_T("     Keeping Cell # %d, VID=%d  CID=%d"),nCell+1,VobId,CellId);
				MyLog(csAux);
				m_TitleCells[nVTS][n].iMode=CELLBASED;
				m_TitleCells[nVTS][n].chMode='K';
				m_TitleCells[nVTS][n].bFixPointers=false;
			}
			break;
		}
	}
}


void CVobBlankerApp::TitleCut(int nVTS,int nT)
{
	int n,nCell;
	__int64  i64IniSec,i64EndSec;
	CString csAux;
	int IniLba,EndLba,IniCell,EndCell,iAction, IniIsClosed, EndIsClosed;


	csAux.Format(_T("VTS %02d: Cutting PGC %02d"),nVTS,nT+1);
	MyLog(csAux);

	iAction=m_CutInfo[nVTS][nT].iAction;
	IniCell=m_CutInfo[nVTS][nT].iIniCell;
	IniLba= m_CutInfo[nVTS][nT].iIniLba;
	EndCell=m_CutInfo[nVTS][nT].iEndCell;
	EndLba= m_CutInfo[nVTS][nT].iEndLba;
	IniIsClosed= m_CutInfo[nVTS][nT].iIniIsClosed;
	EndIsClosed= m_CutInfo[nVTS][nT].iEndIsClosed;
	if (IniCell <0) IniCell=0;
	if (EndCell <0) EndCell=m_nCells[nVTS][nT];
	if (IniLba <0)  IniLba=0;
	if (EndLba <0) 
	{
		i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*m_nCells[nVTS][nT]+8]);
		i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*m_nCells[nVTS][nT]+0x14]);
		EndLba= (int)(i64EndSec-i64IniSec+1) ;
	}

//  Loop cell by cell 
	for (nCell=0; nCell<m_nCells[nVTS][nT] ;nCell++)
	{
		n=TitleCellGetPos( nVTS, nT, nCell);
		if (n <0) 
		{
			MyErrorLog_Box("Error: Cell not found");
			m_bInProcess=false;
			return;
		}

		if (m_TitleCells[nVTS][n].iMode==UNREF)
		{
			if (((nCell < IniCell || nCell > EndCell) && iAction==0 ) ||
				((nCell > IniCell && nCell < EndCell) && iAction!=0 ) ) 
			// Deleted part: Blank Cell
			{
				m_TitleCells[nVTS][n].iMode=BLANK;
				m_TitleCells[nVTS][n].nT=nT;
				m_TitleCells[nVTS][n].bFixPointers=false;
			}
			else
			// Process Cell
			{
				if (((nCell > IniCell && nCell < EndCell) && iAction==0) ||
					((nCell < IniCell || nCell > EndCell) && iAction!=0) )
				{
					// Keep the Cell as it is
					m_TitleCells[nVTS][n].iMode=KEEP;
					m_TitleCells[nVTS][n].nT=nT;
					m_TitleCells[nVTS][n].bFixPointers=false;
		
					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
// Mark Cell with FV_FixVobPointers if required
// Check ILV flag
					if (m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell] & 0x04 )
						m_TitleCells[nVTS][nCell].bFixPointers=true;
				}
				else
				{
// Mark the Cell to be adjusted.  TODO: Check if the Cell is complete. In this case no adjustments are needed
					m_TitleCells[nVTS][n].bFixPointers=true;
					m_TitleCells[nVTS][n].iMode=CUT;
					m_TitleCells[nVTS][n].iCutMode=0;
					m_TitleCells[nVTS][n].nT=nT;
					m_TitleCells[nVTS][n].iFirstIsClosedGOP=1;

				}
				if (nCell == IniCell && nCell != EndCell && iAction==0)
				{	//					________________________
					// CASE 1:			|			|			|
					//					|	DELETE	|	KEEP	|
					//					|___________|___________|

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64IniSec+=IniLba;
					i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64EndSec < i64IniSec) i64IniSec=i64EndSec;
					m_TitleCells[nVTS][n].iFirstIsClosedGOP=IniIsClosed;
					m_TitleCells[nVTS][n].iCutMode=CUT1;
				}
				if (nCell == EndCell  && nCell != IniCell && iAction==0)
				{	//					________________________
					// CASE 2:			|			|			|
					//					|	KEEP	|	DELETE	|
					//					|___________|___________|

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec=i64IniSec+EndLba;
					if ( i64EndSec > GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]))
						i64EndSec = GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64IniSec > i64EndSec) i64EndSec=i64IniSec;
					m_TitleCells[nVTS][n].iFirstIsClosedGOP=1; // First VOBU of cell
					m_TitleCells[nVTS][n].iCutMode=CUT2;
				}
				if (nCell == IniCell && nCell == EndCell && iAction==0)
				{	//					____________________________________
					// CASE 3:			|			|			|			|
					//					|	DELETE	|	KEEP	|	DELETE	|
					//					|___________|___________|___________|

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec= i64IniSec+EndLba;
					i64IniSec+=IniLba;
					if ( i64EndSec > GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]))
						i64EndSec = GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64EndSec < i64IniSec) i64IniSec=i64EndSec;
					m_TitleCells[nVTS][n].iFirstIsClosedGOP=IniIsClosed; 
					m_TitleCells[nVTS][n].iCutMode=CUT3;
				}

				if (nCell == IniCell && nCell != EndCell && iAction!=0)
				{	//					________________________
					// CASE 2b:			|			|			|
					//					|	KEEP	|	DELETE	|
					//					|___________|___________|

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec=i64IniSec+IniLba-1;
					if (i64EndSec > GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]))
					   i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64IniSec > i64EndSec) i64EndSec=i64IniSec;
					m_TitleCells[nVTS][n].iFirstIsClosedGOP=1; // First VOBU of cell
					m_TitleCells[nVTS][n].iCutMode=CUT2;
				}
				if (nCell == EndCell && nCell != IniCell && iAction!=0)
				{	//					________________________
					// CASE 1b:			|			|			|
					//					|	DELETE	|	KEEP	|
					//					|___________|___________|

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64IniSec+=EndLba;
					i64EndSec = GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64EndSec < i64IniSec) i64IniSec=i64EndSec;
					m_TitleCells[nVTS][n].iFirstIsClosedGOP=EndIsClosed; 
					m_TitleCells[nVTS][n].iCutMode=CUT1;
				}

				if (nCell == IniCell && nCell == EndCell && iAction!=0)
				{	//					____________________________________
					// CASE 4:			|			|			|			|
					//					|	KEEP	|	DELETE	|	KEEP	|
					//					|___________|___________|___________|

					// mark Endsector as iniLBa and inisector as endlba.
					// So i64EndSec will be lower than i64IniSec.

					i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec= i64EndSec+IniLba-1;

					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64IniSec= i64IniSec+EndLba;
					m_TitleCells[nVTS][n].iFirstIsClosedGOP=EndIsClosed; 
					m_TitleCells[nVTS][n].iCutMode=CUT4;
				}
				m_TitleCells[nVTS][n].i64IniSecAux=i64IniSec;
				m_TitleCells[nVTS][n].i64EndSecAux=i64EndSec;

				if (    (nCell == EndCell && nCell != IniCell && iAction!=0)
					 || (nCell == IniCell && nCell != EndCell && iAction==0))
				{
				// CASES 1 & 1b
					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);

					if (i64IniSec==m_TitleCells[nVTS][n].i64IniSecAux)
					{
						// Keep the Cell as it is
						m_TitleCells[nVTS][n].iMode=KEEP;
						m_TitleCells[nVTS][n].nT=nT;
						m_TitleCells[nVTS][n].bFixPointers=false;
					}
					if (i64EndSec==m_TitleCells[nVTS][n].i64IniSecAux)
					{
						// Blank the Cell 
						m_TitleCells[nVTS][n].iMode=BLANK;
						m_TitleCells[nVTS][n].nT=nT;
						m_TitleCells[nVTS][n].bFixPointers=false;
					}
				}
				if (   (nCell == EndCell && nCell != IniCell && iAction==0)
					|| (nCell == IniCell && nCell != EndCell && iAction!=0))
				{
				// CASES 2 & 2b
					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
					i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
					if (i64EndSec==m_TitleCells[nVTS][n].i64EndSecAux)
					{
						// Keep the Cell as it is
						m_TitleCells[nVTS][n].iMode=KEEP;
						m_TitleCells[nVTS][n].nT=nT;
						m_TitleCells[nVTS][n].bFixPointers=false;
					}
					if (i64IniSec==m_TitleCells[nVTS][n].i64EndSecAux)
					{
						// Blank the Cell 
						m_TitleCells[nVTS][n].iMode=BLANK;
						m_TitleCells[nVTS][n].nT=nT;
						m_TitleCells[nVTS][n].bFixPointers=false;
					}

				}

			} // else process cell
		}
	}
}


void CVobBlankerApp::TitleStrip(int nVTS,int nT)
{

	int n,nCell;
	CString csAux;

	csAux.Format(_T("VTS %02d: Stripping PGC %02d"),nVTS,nT+1);
	MyLog(csAux);

	for (nCell=0; nCell<m_nCells[nVTS][nT] ;nCell++)
	{
		n=TitleCellGetPos( nVTS, nT, nCell);
		if (n <0) 
		{
			MyErrorLog_Box("Error: Cell not found");
			m_bInProcess=false;
			return;
		}
		if (m_TitleCells[nVTS][n].iMode==UNREF)
		{
			m_TitleCells[nVTS][n].iMode=STRIP;
			m_TitleCells[nVTS][n].bFixPointers=true;
			m_TitleCells[nVTS][n].nT=nT;	// To access to STRIP INFO
		}
	}
}

void CVobBlankerApp::TitleReplace(int nVTS,int nT)
{
	int n,nCell,LastnCell;
	int i,l;
	int CellsToBeReplaced;
	CString csAux;
	struct  _stati64 statbuf;
	uchar* pRIFO;
	__int64 i64RIFOsize,i64IFOlen;
	int nRPGCs,nRepCells;
	int REP_VTS_PGCI,REP_VTS_PGC,REP_C_PBKT,REP_C_POST;


	csAux.Format(_T("VTS %02d: Replacing PGC %02d by %s"),nVTS,nT+1,m_csReplace[nVTS][nT]);
	MyLog(csAux);


/// Open the IFO and read the sector values
	csAux=m_csReplace[nVTS][nT];
	m_csFin=csAux.Left(csAux.GetLength()-5)+"0.IFO";
	if (_stati64 ( m_csFin, &statbuf)==0)
	{
		i64RIFOsize= statbuf.st_size;
	}
	else
	{
		MyErrorLog_Box("Error: Unable to stat " + m_csFin);
		m_bInProcess=false;
		return;
	}

	if (i64RIFOsize >MAXLENGTH )	
	{
		MyErrorBox ("ERROR: Ifo file too big: "+m_csFin);
		m_bInProcess=false;
		return;
	}

	i64RIFOsize=i64RIFOsize+2048; // Allow One additional sectors

	pRIFO= new uchar[(int)i64RIFOsize];

	if ((m_Fin=fopen(m_csFin,"rb"))==NULL)
	{
		MyErrorBox ("Unable to open input IFO file: "+m_csFin);
		m_bInProcess=false;
		return;
	}
	for (i=0;!feof(m_Fin) && i< i64RIFOsize ;i++)
		pRIFO[i]=fgetc(m_Fin);
	i64IFOlen=i-1;
	
	if (m_Fin!=NULL) fclose(m_Fin);

	REP_VTS_PGCI=2048*GetNbytes(4,&pRIFO[0xCC]);
	nRPGCs=GetNbytes(2,&pRIFO[REP_VTS_PGCI]);

	if ( nRPGCs != 1)
	{
		MyErrorBox ("ERROR: Ifo has more than one PGC: Unsupported "+m_csFin);
		m_bInProcess=false;
		return;
	}

	REP_VTS_PGC=GetNbytes(4,&pRIFO[REP_VTS_PGCI+0x04+8])+REP_VTS_PGCI;
	REP_C_PBKT=GetNbytes(2,&pRIFO[REP_VTS_PGC+0xE8]);
	if (REP_C_PBKT!=0 ) REP_C_PBKT+=REP_VTS_PGC;
	REP_C_POST=GetNbytes(2,&pRIFO[REP_VTS_PGC+0xEA]);
	if (REP_C_POST!=0  ) REP_C_POST+=REP_VTS_PGC;
	
	nRepCells=pRIFO[REP_VTS_PGC+3];
	if (REP_C_POST==0 || REP_C_PBKT==0  ||  nRepCells==0)
		// Seems something is wrong so quit.....
	{
		MyErrorBox ("ERROR: There is something wrong in number of cells in "+m_csFin);
		m_bInProcess=false;
		return;
	}

	LastnCell=-1;
	for (nCell=CellsToBeReplaced=0; nCell<m_nCells[nVTS][nT] ;nCell++)
	{
		n=TitleCellGetPos( nVTS, nT, nCell);
		if (n <0) 
		{
			MyErrorLog_Box("Error: Cell not found");
			m_bInProcess=false;
			return;
		}
		if (m_TitleCells[nVTS][n].iMode==UNREF)
		{
			m_TitleCells[nVTS][n].iMode=REPLACE;
			if (!m_bCheckFixVobsReplacing)
				m_TitleCells[nVTS][n].bFixPointers=false;
			else
				m_TitleCells[nVTS][n].bFixPointers=true;

			m_TitleCells[nVTS][n].nT=nT;	// To access to m_csReplace

			if (CellsToBeReplaced < nRepCells)
			{
				l=CellsToBeReplaced;
				m_TitleCells[nVTS][n].i64IniSecAux=GetNbytes(4,&pRIFO[REP_C_PBKT+24*l+8]);
				m_TitleCells[nVTS][n].i64EndSecAux=GetNbytes(4,&pRIFO[REP_C_PBKT+24*l+0x14]);
			}
			else
			{
// No more cells in Replacing title
				m_TitleCells[nVTS][n].i64IniSecAux=-1;
				m_TitleCells[nVTS][n].i64EndSecAux=-1;
			}

			CellsToBeReplaced++;
			LastnCell=nCell;
		}
	}

	csAux.Format(_T("     Cells to be replaced  =%d."),CellsToBeReplaced);
	MyLog(csAux);
	csAux.Format(_T("     Cells in replacing VOB=%d "),nRepCells);
	MyLog(csAux);

	if (CellsToBeReplaced < nRepCells)
	{
// More cells in Replacing title, so extend last cell
		n=TitleCellGetPos( nVTS, nT, LastnCell);
		if (n <0) 
		{
			MyErrorLog_Box("Error: Cell not found");
			m_bInProcess=false;
			return;
		}

		m_TitleCells[nVTS][n].i64EndSecAux=GetNbytes(4,&pRIFO[REP_C_PBKT+24*(nRepCells-1)+0x14]);

		MyLog("     WARNING: Number of Cells higher in replacing title. Extending last cell",ORANGE);
		m_nWarnings++;
	}
	if (CellsToBeReplaced > nRepCells)
	{
// Less cells in Replacing title, so blank the last ones
		MyLog("     WARNING: Number of Cells lower in replacing title. Blanking last ones",ORANGE);
		m_nWarnings++;
	}

	if (REP_C_PBKT!=0)
	{
		for (nCell=0; nCell< CellsToBeReplaced && nCell < nRepCells; nCell++)
		{
			n=TitleCellGetPos(nVTS,nT,nCell);
			m_TitleCells[nVTS][n].uCellStatus=pRIFO[REP_C_PBKT+nCell*24];
		}
	}
	if (CellsToBeReplaced > nRepCells && nRepCells>0)
	{
		for (nCell=nRepCells; nCell < CellsToBeReplaced; nCell++)
		{
			n=TitleCellGetPos(nVTS,nT,nCell);
			m_TitleCells[nVTS][n].uCellStatus=pRIFO[REP_C_PBKT+(nRepCells-1)*24];
		}

	}

	delete [] pRIFO;
}



///////////////////////////////////////////////////////////////////////////
///             Cell Methods, called in Second phase   ////////////////////
///////////////////////////////////////////////////////////////////////////

int CVobBlankerApp::TitleCellGetPos(int nVTS,int nT,int nCell)
{
// Returns the position in the array (from 0 to n-1). Returns -1 if not present.
	int CellId,VobId;
	int i,ii,iACells;
	bool bAlready;

	CellId=m_pIFO[nVTS][m_C_POST[nVTS][nT]+nCell*4+3];
	VobId=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+nCell*4]);
	iACells=m_TitleCells[nVTS].GetSize();

	for (i=0, bAlready=false; i<iACells && bAlready==false; i++)
	{
		if (m_TitleCells[nVTS][i].CID == CellId &&
			m_TitleCells[nVTS][i].VID == VobId )
		{
			bAlready=true;
			ii=i;
		}
	}

	if (bAlready==false)
		return -1;
	return ii;
}

int CVobBlankerApp::TitleCellGetPosByVCID(int nVTS, int VobId,int CellId)
{
// Returns the position in the array (from 0 to n-1). Returns -1 if not present.
// Returns the first cell with VID/CID (iPart=0)
	int i,ii,iACells;
	bool bAlready;

	
	iACells=m_TitleCells[nVTS].GetSize();

	for (i=0, bAlready=false; i<iACells && bAlready==false; i++)
	{
		if (m_TitleCells[nVTS][i].CID == CellId &&
			m_TitleCells[nVTS][i].VID == VobId )
		{
			bAlready=true;
			ii=i;
		}
	}
	if (bAlready==false)
		return -1;
	return ii;
}

void CVobBlankerApp::TitleCellKeep(int nVTS,int nCell, CWnd* pDlg)
{

	int k,nT;
	__int64 i64sectors, i64IniSec,i64EndSec,i64;
	CString csAux;
	bool bMyCell,bAlreadyNav;
	int VID,CID,NVID,NCID;
	int nPads;

//  Locate the cell
	i64sectors=0;
	i64IniSec=m_TitleCells[nVTS][nCell].i64IniSecCell;
	i64EndSec=m_TitleCells[nVTS][nCell].i64EndSecCell;
	VID=m_TitleCells[nVTS][nCell].VID;
	CID=m_TitleCells[nVTS][nCell].CID;
	NVID=m_TitleCells[nVTS][nCell].NVID;
	NCID=m_TitleCells[nVTS][nCell].NCID;
	nT=m_TitleCells[nVTS][nCell].nT;

	if( m_TitleCells[nVTS][nCell].iMode!=CELLBASED)
	{
		csAux.Format(_T("VTS %02d: Keeping Cell VID/CID: %02d/%02d --> %02d/%02d"),
			nVTS,VID,CID,NVID,NCID);
		MyLog(csAux);
	}

	i64sectors=0;
	for (k=1,m_nVobin=1;k<10;k++)
	{
		i64sectors+=(m_i64VOBsize[nVTS][k]/2048);
		if (i64IniSec<i64sectors)
		{
			i64sectors-=(m_i64VOBsize[nVTS][k]/2048);
			m_nVobin=k;
			k=20;
		}
	}

	csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
	m_csFin=m_csInputPath+ '\\' +csAux;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}
	fseek(m_Fin, (long) ((i64IniSec-i64sectors)*2048), SEEK_SET);

	bAlreadyNav=false;
	nPads=0;
	for (i64=0,bMyCell=true;i64< (i64EndSec-i64IniSec+1) && m_bInProcess==true;i64++)
	{
	//readpack
		if ((i64%MODUPDATE) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA), true);
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			if (m_Fin!=NULL) fclose (m_Fin);
			m_nVobin++;
			csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
			m_csFin=m_csInputPath+ '\\' +csAux;
			m_Fin=fopen(m_csFin,"rb");
			if (readbuffer(m_buffer,m_Fin)!=2048)
			{
				MyErrorLog_Box("Input error: Reached end of VOB too early");
				m_bInProcess=false;
				return;
			}
		}
		if (IsSynch(m_buffer) != true)
		{
			if (nPads==0)
				MyLog("    WARNING: Packs unsynchronized. Skipping packs...",ORANGE); 
			nPads++;
		}
		else if (m_bInProcess==true)
		{
			if (IsNav(m_buffer))
			{
				if (m_buffer[0x420]==(uchar)(VID%256) &&
					m_buffer[0x41F]==(uchar)(VID/256) &&
					m_buffer[0x422]== (uchar) CID)
					bMyCell=true;
				else
					bMyCell=false;
				if (bMyCell)
				{
					bAlreadyNav=true;
					ModifyCID (m_buffer,NVID, NCID);
					if (CleanILV(m_buffer))
						m_TitleCells[nVTS][nCell].bFixPointers=true;
					WritePack (m_buffer,nVTS);
				}
			}
			else
			{
				if (bMyCell)	WritePack (m_buffer,nVTS);
			}
		}
	}
	if (m_Fin!=NULL) fclose (m_Fin);
	m_Fin=NULL;

	if (!bAlreadyNav)
	{
		MyLog("    WARNING: No Navs found!: outputting a blank cell",ORANGE); 
		m_nWarnings++;
		OutputBlankCell(nVTS,NVID,NCID);
	}
	if (nPads!=0)
	{
		csAux.Format(_T("    A total of %d packs have been skipped"),nPads);
		MyLog(csAux,ORANGE);
	}
}

void CVobBlankerApp::TitleCellSplit(int nVTS, int nCell, CWnd* pDlg)
{

	int k,nT;
	__int64 i64sectors, i64IniSec,i64EndSec,i64IntSec1,i64IntSec2,i64;
	CString csAux;
	bool bMyCell,bAlreadyNav, bLookForFirstVideo;
	int VID,CID,NVID,NCID,iPart,iFirstIsClosedGOP;
	int nPads;

//  Locate the cell
	i64sectors=0;
	i64IniSec=m_TitleCells[nVTS][nCell].i64IniSecCell;
	i64EndSec=m_TitleCells[nVTS][nCell].i64EndSecCell;
	i64IntSec1=i64IniSec+m_TitleCells[nVTS][nCell].i64IFrame1;
	i64IntSec2=i64IniSec+m_TitleCells[nVTS][nCell].i64IFrame2;
	VID=m_TitleCells[nVTS][nCell].VID;
	CID=m_TitleCells[nVTS][nCell].CID;
	NVID=m_TitleCells[nVTS][nCell].NVID;
	NCID=m_TitleCells[nVTS][nCell].NCID;
	nT=m_TitleCells[nVTS][nCell].nT;
	iPart=m_TitleCells[nVTS][nCell].iPart;
	iFirstIsClosedGOP=m_TitleCells[nVTS][nCell].iFirstIsClosedGOP;

///////////////////////////////////////////////////////////////////7
// First part of the Cell
	if (iPart==0)
	{
		csAux.Format(_T("     First part: From sector: %I64d  to %I64d. Total=%I64d"), 
					i64IniSec , i64IntSec1, i64IntSec1-i64IniSec);
		MyLog(csAux); 
		i64sectors=0;
		for (k=1,m_nVobin=1;k<10;k++)
		{
			i64sectors+=(m_i64VOBsize[nVTS][k]/2048);
			if (i64IniSec<i64sectors)
			{
				i64sectors-=(m_i64VOBsize[nVTS][k]/2048);
				m_nVobin=k;
				k=20;
			}
		}	

		csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
		m_csFin=m_csInputPath+ '\\' +csAux;
		m_Fin=fopen(m_csFin,"rb");
		if (m_Fin ==NULL)
		{
			MyErrorLog_Box("Error opening input VOB: "+m_csFin);
			m_bInProcess=false;
			return;
		}
		fseek(m_Fin, (long) ((i64IniSec-i64sectors)*2048), SEEK_SET);	

		bAlreadyNav=false;
		nPads=0;
		for (i64=0,bMyCell=true;i64< (i64IntSec1-i64IniSec) && m_bInProcess==true;i64++)
		{
		//readpack
			if ((i64%MODUPDATE) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA), true);
			if (readbuffer(m_buffer,m_Fin)!=2048)
			{
				if (m_Fin!=NULL) fclose (m_Fin);
				m_nVobin++;
				csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
				m_csFin=m_csInputPath+ '\\' +csAux;
				m_Fin=fopen(m_csFin,"rb");
				if (readbuffer(m_buffer,m_Fin)!=2048)
				{
					MyErrorLog_Box("Input error: Reached end of VOB too early");
					m_bInProcess=false;
					return;
				}
			}
			if (IsSynch(m_buffer) != true)
			{
				if (nPads==0)
					MyLog("    WARNING: Packs unsynchronized. Skipping packs...",ORANGE); 
				nPads++;
			}
			else if (m_bInProcess==true)
			{
				if (IsNav(m_buffer))
				{
					if (m_buffer[0x420]==(uchar)(VID%256) &&
						m_buffer[0x41F]==(uchar)(VID/256) &&
						m_buffer[0x422]== (uchar) CID)
						bMyCell=true;
					else
						bMyCell=false;
					if (bMyCell)
					{
						bAlreadyNav=true;
						ModifyCID (m_buffer,NVID, NCID);
						CleanILV(m_buffer);
						WritePack (m_buffer,nVTS);
					}
				}
				else
				{
					if (bMyCell)	WritePack (m_buffer,nVTS);
				}
			}
		}
		if (m_Fin!=NULL) fclose (m_Fin);
		m_Fin=NULL;	
	}
	else if (iPart==1)
	{

////////////////////////////////////////////////
//// Second part of the Cell
		csAux.Format(_T("     Second part: From sector: %I64d  to %I64d. Total=%I64d"), 
					i64IntSec2 , i64EndSec, i64EndSec-i64IntSec2+1);
		MyLog(csAux); 
		i64sectors=0;
		for (k=1,m_nVobin=1;k<10;k++)
		{
			i64sectors+=(m_i64VOBsize[nVTS][k]/2048);
			if (i64IntSec2<i64sectors)
			{
				i64sectors-=(m_i64VOBsize[nVTS][k]/2048);
				m_nVobin=k;
				k=20;
			}
		}	

		csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
		m_csFin=m_csInputPath+ '\\' +csAux;
		m_Fin=fopen(m_csFin,"rb");
		if (m_Fin ==NULL)
		{
			MyErrorLog_Box("Error opening input VOB: "+m_csFin);
			m_bInProcess=false;
			return;
		}
		fseek(m_Fin, (long) ((i64IntSec2-i64sectors)*2048), SEEK_SET);	

		m_iFixDuration=GETOFFDURATION;

		bAlreadyNav=false;
		bLookForFirstVideo=true;
		nPads=0;
		for (i64=0,bMyCell=true;i64< (i64EndSec-i64IntSec2+1) && m_bInProcess==true;i64++)
		{
		//readpack
			if ((i64%MODUPDATE) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA), true);
			if (readbuffer(m_buffer,m_Fin)!=2048)
			{
				if (m_Fin!=NULL) fclose (m_Fin);
				m_nVobin++;
				csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
				m_csFin=m_csInputPath+ '\\' +csAux;
				m_Fin=fopen(m_csFin,"rb");
				if (readbuffer(m_buffer,m_Fin)!=2048)
				{
					MyErrorLog_Box("Input error: Reached end of VOB too early");
					m_bInProcess=false;
					return;
				}
			}
			if (IsSynch(m_buffer) != true)
			{
				if (nPads==0)
					MyLog("    WARNING: Packs unsynchronized. Skipping packs...",ORANGE); 
				nPads++;
			}
			else if (m_bInProcess==true)
			{
				if (IsNav(m_buffer))
				{
					if (bAlreadyNav==false && i64 !=0 ) 
					{
						MyErrorLog_Box("Error: Split sector is not a Nav pack");
						m_bInProcess=false;
						return;
					}
					if (m_buffer[0x420]==(uchar)(VID%256) &&
						m_buffer[0x41F]==(uchar)(VID/256) &&
						m_buffer[0x422]== (uchar) CID)
						bMyCell=true;
					else
						bMyCell=false;
					if (bMyCell)
					{
						bAlreadyNav=true;
						ModifyCID (m_buffer,NVID, NCID);
						CleanILV(m_buffer);
						WritePack (m_buffer,nVTS);
					}
				}
				else
				{
					if (bMyCell)
					{
						if (bLookForFirstVideo && iFirstIsClosedGOP==0 && IsVideo(m_buffer) )
						{
							bLookForFirstVideo=false;
							SetBreakGOP(m_buffer);
						}
						WritePack (m_buffer,nVTS);
					}
				}
			}
		}
		if (m_Fin!=NULL) fclose (m_Fin);
		m_Fin=NULL;
	}
	else
	{
		MyErrorLog_Box("Error: Split an unknown part");
		m_bInProcess=false;
		return;
	}
	if (!bAlreadyNav)
	{
		MyLog("    WARNING: No Navs found!: outputting a blank cell",ORANGE); 
		m_nWarnings++;
		OutputBlankCell(nVTS,NVID,NCID);
	}
	if (nPads!=0)
	{
		csAux.Format(_T("    A total of %d packs have been skipped"),nPads);
		MyLog(csAux,ORANGE);
	}

}

void CVobBlankerApp::TitleCellBlank(int nVTS,int nCell, CWnd* pDlg)
{
	CString csAux;
	int VID,CID,NVID,NCID;

	VID=m_TitleCells[nVTS][nCell].VID;
	CID=m_TitleCells[nVTS][nCell].CID;
	NVID=m_TitleCells[nVTS][nCell].NVID;
	NCID=m_TitleCells[nVTS][nCell].NCID;

	csAux.Format(_T("VTS %02d: Blanking Cell VID/CID: %02d/%02d --> %02d/%02d"),nVTS,
		 VID,CID, NVID, NCID );
    MyLog(csAux);

	OutputBlankCell(nVTS, NVID, NCID);
}

void CVobBlankerApp::TitleCellUnref(int nVTS,int nCell, CWnd* pDlg)
{
	CString csAux;
	int VID,CID,NVID,NCID;

	VID=m_TitleCells[nVTS][nCell].VID;
	CID=m_TitleCells[nVTS][nCell].CID;
	NVID=m_TitleCells[nVTS][nCell].NVID;
	NCID=m_TitleCells[nVTS][nCell].NCID;

	csAux.Format(_T("VTS %02d: Blanking unref Cell VID/CID: %02d/%02d --> %02d/%02d"),
		nVTS,VID,CID,NVID,NCID);
    MyLog(csAux);

	OutputBlankCell(nVTS, NVID, NCID);
}


void CVobBlankerApp::TitleCellBasedCell(int nVTS,int nCell, CWnd* pDlg)
{
	int k;
	CString csAux,csVTS;
	int VID,CID,NVID,NCID;
	int OldCellId, OldVobId;
	__int64 i64,i64CellLBA;
	struct  _stati64 statbuf;
	DWORD dwVOBUDuration;
	bool bWarning;

	csVTS.Format(_T("VTS %02d: (CB) "),nVTS);

	VID=m_TitleCells[nVTS][nCell].VID;
	CID=m_TitleCells[nVTS][nCell].CID;
	NVID=m_TitleCells[nVTS][nCell].NVID;
	NCID=m_TitleCells[nVTS][nCell].NCID;

	switch (m_TitleCells[nVTS][nCell].chMode)
	{
	case 'R':
		csAux.Format(_T("Replacing Cell VID/CID: %02d/%02d --> %02d/%02d"),VID,CID,NVID,NCID);
		MyLog(csVTS+csAux);

		m_csFin=m_ACell_replace[m_TitleCells[nVTS][nCell].indexReplace].csPath;

		m_Fin=NULL;
		if (! (m_csFin.IsEmpty()) )  m_Fin=fopen(m_csFin,"rb");

		if (m_Fin ==NULL)
		{
			MyErrorLog_Box("Error opening input VOB: "+m_csFin);
			m_bInProcess=false;
			return;
		}

		if (_stati64 ( m_csFin, &statbuf)==0)
			i64CellLBA=statbuf.st_size/2048;

		OldCellId=OldVobId=-1;
		bWarning=false;

// Seems compatible with ADDOFFDURATION....
		if (m_bCheckElapsed) m_iFixDuration=GETOFFDURATION;

		for (i64=0 ; i64<i64CellLBA && m_bInProcess==true ; i64++)
		{
			if ((i64%MODUPDATE) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA), true);
			if (readbuffer(m_buffer,m_Fin)!=2048)
			{
				MyErrorLog_Box("Input error: Reached end of VOB too early");
				m_bInProcess=false;
				return;
			}
			if (IsSynch(m_buffer) != true)
			{
				MyErrorLog_Box("Error reading input VOB: Unsynchronized");
				m_bInProcess=false;
				return;
			}

			if (m_bInProcess==true)
			{
				if (IsNav(m_buffer))
				{
					if (OldVobId==-1)
					{
						OldVobId=GetNbytes(2,&m_buffer[0x41F]);
						OldCellId=m_buffer[0x422];
					}
					else
					{
						if (OldVobId!=(int)GetNbytes(2,&m_buffer[0x41F]) || 
							OldCellId!=m_buffer[0x422])
						{
						// A new Cell has been detected
							OldVobId=GetNbytes(2,&m_buffer[0x41F]);
							OldCellId=m_buffer[0x422];
							if (!bWarning)
							{
								bWarning=true;
								MyLog("     WARNING: Number of Cells in replacing VOB higher than one. Continuing with same cell VID/CID",ORANGE);
								m_nWarnings++;
							}
							k=m_ANavinfo.GetSize()-1;
							if (k>=0)
							{
								m_iFixDuration=ADDOFFDURATION;
								m_dwOffDuration=m_ANavinfo[k].dwDuration;
								dwVOBUDuration=(m_ANavinfo[k].iPTS1-m_ANavinfo[k].iPTS0)/(m_ticsperframe);
								dwVOBUDuration=Dec2BCD(dwVOBUDuration);
								dwVOBUDuration=dwVOBUDuration|(m_dwOffDuration & 0xc0);
								m_dwOffDuration=AddDuration(m_dwOffDuration,dwVOBUDuration);
							}
						}
					}
					ModifyCID (m_buffer,NVID, NCID);
					CleanILV(m_buffer);
				}
				WritePack(m_buffer,nVTS);
			}
		}
		if (m_Fin !=NULL) { fclose(m_Fin); m_Fin=NULL;}
		break;
	case 'B':
		csAux.Format(_T("Blanking Cell VID/CID: %02d/%02d --> %02d/%02d"),VID,CID,NVID,NCID);
		MyLog(csVTS+csAux);

		OutputBlankCell(nVTS, NVID, NCID);

		break;
	case 'S':
		csAux.Format(_T("Stilling with audio Cell VID/CID: %02d/%02d --> %02d/%02d"),VID,CID,NVID,NCID);
		MyLog(csVTS+csAux);
		TitleCellStill (nVTS, nCell,true, m_TitleCells[nVTS][nCell].i64IFrame1, pDlg);

		break;
	case 'P':
		csAux.Format(_T("Splitting Cell VID/CID: %02d/%02d --> %02d/%02d"),VID,CID,NVID,NCID);
		MyLog(csVTS+csAux);
		TitleCellSplit(nVTS,nCell, pDlg);

		break;
	case 'C':
		if (m_TitleCells[nVTS][nCell].iCutMode < CUT4S)
		{
// Normal Cut
			csAux.Format(_T("Cutting Cell VID/CID: %02d/%02d --> %02d/%02d"),VID,CID,NVID,NCID);
			MyLog(csVTS+csAux);
			TitleCellCut(nVTS,nCell,pDlg);
		}
		else
		{
// Cut + Split
			csAux.Format(_T("Cutting+Splitting Cell VID/CID: %02d/%02d --> %02d/%02d"),VID,CID,NVID,NCID);
			MyLog(csVTS+csAux);
			TitleCellSplit(nVTS,nCell, pDlg);
		}


		break;
	case 'K':
	default:
		csAux.Format(_T("Keeping Cell VID/CID: %02d/%02d --> %02d/%02d"),VID,CID,NVID,NCID);
		MyLog(csVTS+csAux);

		TitleCellKeep(nVTS,nCell, pDlg);
	break;
	}
}


void CVobBlankerApp::TitleCellCut(int nVTS,int nCell, CWnd* pDlg)
{

	int k,nT;
	int VID,CID,NVID,NCID;
	__int64 i64sectors, i64;
	__int64 i64IniSec,i64EndSec,i64IniCut,i64EndCut;
	__int64 i64IniCut1,i64EndCut1,i64IniCut2,i64EndCut2;
	CString csAux;
	bool bAlreadyNav;
	bool bLookForFirstVideo;
	bool bMyCell;
	int iFirstIsClosedGOP,iFixDuration1,iFixDuration2;
	bool bTwoPasses;
	int nNavs;
	int nPads;


//  Locate the cell
	i64sectors=0;
	i64IniSec=m_TitleCells[nVTS][nCell].i64IniSecCell;
	i64EndSec=m_TitleCells[nVTS][nCell].i64EndSecCell;
	i64IniCut=m_TitleCells[nVTS][nCell].i64IniSecAux;
	i64EndCut=m_TitleCells[nVTS][nCell].i64EndSecAux;
	iFirstIsClosedGOP=m_TitleCells[nVTS][nCell].iFirstIsClosedGOP;

	VID=m_TitleCells[nVTS][nCell].VID;
	CID=m_TitleCells[nVTS][nCell].CID;
	NVID=m_TitleCells[nVTS][nCell].NVID;
	NCID=m_TitleCells[nVTS][nCell].NCID;

	nT=m_TitleCells[nVTS][nCell].nT;

	if( m_TitleCells[nVTS][nCell].iMode!=CELLBASED)
	{
		csAux.Format(_T("VTS %02d: Cutting Cell VID/CID: %02d/%02d --> %02d/%02d"),
			nVTS,VID,CID,NVID,NCID);
		MyLog(csAux);
	}


	if (i64EndCut==i64IniCut)
	{
		MyLog("    WARNING: Ini and end mark are the same: outputting a blank cell",ORANGE); 
		m_nWarnings++;
		OutputBlankCell(nVTS,NVID,NCID);
		return;
	}

	//					________________________
	// CASE 1:			|			|			|
	//					|	DELETE	|	KEEP	|
	//					|___________|___________|
	//					________________________
	// CASE 2:			|			|			|
	//					|	KEEP	|	DELETE	|
	//					|___________|___________|
	//					____________________________________
	// CASE 3:			|			|			|			|
	//					|	DELETE	|	KEEP	|	DELETE	|
	//					|___________|___________|___________|
	//					____________________________________
	// CASE 4:			|			|			|			|
	//					|	KEEP	|	DELETE	|	KEEP	|
	//					|___________|___________|___________|

	if (i64EndCut > i64IniCut)
	{
// CASES 1, 2 & 3;
		if (i64IniCut!= i64IniSec) 
		{
		// CASE 1 & 3
			iFixDuration1=GETOFFDURATION;
			bLookForFirstVideo=true;
		}
		else
		{
		// CASE 2
			iFixDuration1=0;
			bLookForFirstVideo=false;
		}
		i64EndCut1=i64EndCut;
		i64IniCut1=i64IniCut;
		bTwoPasses=false;
	}
	else
	{
// CASE 4;
		bLookForFirstVideo=false;
		i64IniCut1=i64IniSec;
		i64EndCut1=i64EndCut; //OJO
		iFixDuration1=SAVEOFFDURATION;

// Second pass always looks for first video.
		i64IniCut2=i64IniCut;
		i64EndCut2=i64EndSec;
		iFixDuration2=CALCULATE_FIXOFFDURATION;
		bTwoPasses=true;
	}

	i64sectors=0;
	for (k=1,m_nVobin=1;k<10;k++)
	{
		i64sectors+=(m_i64VOBsize[nVTS][k]/2048);
		if (i64IniCut1<i64sectors)
		{
			i64sectors-=(m_i64VOBsize[nVTS][k]/2048);
			m_nVobin=k;
			k=20;
		}
	}

	csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
	m_csFin=m_csInputPath+ '\\' +csAux;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}

	fseek(m_Fin, (long) ((i64IniCut1-i64sectors)*2048), SEEK_SET);

	// Guarantee to start with a Nav Pack
	bAlreadyNav=false;
	m_iFixDuration=iFixDuration1;
	nNavs=0;
	nPads=0;
	for (i64=0,bMyCell=true;i64< (i64EndCut1-i64IniCut1+1) && i64EndCut1!=i64IniCut1 && m_bInProcess==true;i64++)
	{
	//readpack
		if ((i64%MODUPDATE) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA), true);
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			if (m_Fin!=NULL) fclose (m_Fin);
			m_nVobin++;
			csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
			m_csFin=m_csInputPath+ '\\' +csAux;
			m_Fin=fopen(m_csFin,"rb");
			if (readbuffer(m_buffer,m_Fin)!=2048)
			{
				MyErrorLog_Box("Input error: Reached end of VOB too early");
				m_bInProcess=false;
				return;
			}
		}
		if (IsSynch(m_buffer) != true)
		{
			if (nPads==0)
				MyLog("    WARNING: Packs unsynchronized. Skipping packs...",ORANGE); 
			nPads++;
		}
		else if (m_bInProcess==true)
		{
			if (IsNav(m_buffer))
			{
				if (m_buffer[0x420]==(uchar)(VID%256) &&
					m_buffer[0x41F]==(uchar)(VID/256) &&
					m_buffer[0x422]== (uchar) CID)
					bMyCell=true;
				else
					bMyCell=false;

				if (bMyCell)
				{
					ModifyCID (m_buffer,NVID, NCID);
					bAlreadyNav=true;
					nNavs++;
					WritePack (m_buffer,nVTS);
				}
			}
			else
			{
				if (bMyCell && bAlreadyNav)
				{
					if (bLookForFirstVideo && iFirstIsClosedGOP==0 && IsVideo(m_buffer) )
					{
						bLookForFirstVideo=false;
						SetBreakGOP(m_buffer);
					}
					WritePack (m_buffer,nVTS);
				}
			}
		}
	}


	if (m_Fin!=NULL) fclose (m_Fin);
	m_Fin=NULL;

	if (!bTwoPasses) 
	{
		if (nNavs ==0)
		{
			MyLog("    WARNING: No Navs found!: outputting a blank cell",ORANGE); 
			m_nWarnings++;
			OutputBlankCell(nVTS,NVID,NCID);
		}
		if (nPads!=0)
		{
			csAux.Format(_T("    A total of %d packs have been skipped"),nPads);
			MyLog(csAux,ORANGE);
		}
		return;
	}
// Second pass	
	i64sectors=0;
	for (k=1,m_nVobin=1;k<10;k++)
	{
		i64sectors+=(m_i64VOBsize[nVTS][k]/2048);
		if (i64IniCut2<i64sectors)
		{
			i64sectors-=(m_i64VOBsize[nVTS][k]/2048);
			m_nVobin=k;
			k=20;
		}
	}

	csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
	m_csFin=m_csInputPath+ '\\' +csAux;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}

	fseek(m_Fin, (long) ((i64IniCut2-i64sectors)*2048), SEEK_SET);

	// Guarantee to start with a Nav Pack
	bAlreadyNav=false;
	bLookForFirstVideo=true;  //always in second pass
	m_iFixDuration=iFixDuration2;


	for (i64=0,bMyCell=true;i64< (i64EndCut2-i64IniCut2+1) && i64EndCut2!=i64IniCut2 && m_bInProcess==true;i64++)
	{
	//readpack
		if ((i64%MODUPDATE) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA), true);
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			if (m_Fin!=NULL) fclose (m_Fin);
			m_nVobin++;
			csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
			m_csFin=m_csInputPath+ '\\' +csAux;
			m_Fin=fopen(m_csFin,"rb");
			if (readbuffer(m_buffer,m_Fin)!=2048)
			{
				MyErrorLog_Box("Input error: Reached end of VOB too early");
				m_bInProcess=false;
				return;
			}
		}
		if (IsSynch(m_buffer) != true)
		{
			if (nPads==0)
				MyLog("    WARNING: Packs unsynchronized. Skipping packs...",ORANGE); 
			nPads++;
		}
		else if (m_bInProcess==true)
		{
			if (IsNav(m_buffer))
			{
				if (m_buffer[0x420]==(uchar)(VID%256) &&
					m_buffer[0x41F]==(uchar)(VID/256) &&
					m_buffer[0x422]== (uchar) CID)
					bMyCell=true;
				else
					bMyCell=false;

				if (bMyCell)
				{
					ModifyCID (m_buffer,NVID, NCID);
					bAlreadyNav=true;
					nNavs++;
					WritePack (m_buffer,nVTS);
				}
			}
			else
			{
				if (bMyCell && bAlreadyNav)
				{
					if (bLookForFirstVideo && iFirstIsClosedGOP==0 && IsVideo(m_buffer) )
					{
						bLookForFirstVideo=false;
						SetBreakGOP(m_buffer);
					}
					WritePack (m_buffer,nVTS);
				}
			}
		}
	}
	if (nNavs ==0)
	{
		MyLog("    WARNING: No Navs found!: outputting a blank cell",ORANGE); 
		m_nWarnings++;
		OutputBlankCell(nVTS,NVID,NCID);
	}
	if (nPads!=0)
	{
		csAux.Format(_T("    A total of %d packs have been skipped"),nPads);
		MyLog(csAux,ORANGE);
	}
	if (m_Fin!=NULL) fclose (m_Fin);
	m_Fin=NULL;
}


void CVobBlankerApp::TitleCellStrip(int nVTS,int nCell, CWnd* pDlg)
{
	int j,k;
	int VID,CID,NVID,NCID;
	__int64 i64sectors, i64IniSec,i64EndSec,i64;
	CString csAux;
	bool   bKeepPack;
	bool	bKeep[32],bStrip[32], bAudioStrip[8],bSubsStrip[32] ;
	int nA,nAA,nS,nSS,nT;
	int ilastpack;
	__int64 i64aux,i64auxp1,i64auxp2,i64auxp3,i64auxp4;
	uchar AudStatus0, SubStatus0, SubStatus1,SubStatus2,SubStatus3;
	bool b43,bWI,bLB,bPS;
	FILE * flog;



//  Locate the cell
	i64sectors=0;
	i64IniSec=m_TitleCells[nVTS][nCell].i64IniSecCell;
	i64EndSec=m_TitleCells[nVTS][nCell].i64EndSecCell;
	VID=m_TitleCells[nVTS][nCell].VID;
	CID=m_TitleCells[nVTS][nCell].CID;
	NVID=m_TitleCells[nVTS][nCell].NVID;
	NCID=m_TitleCells[nVTS][nCell].NCID;
	nT=m_TitleCells[nVTS][nCell].nT;

	m_TitleCells[nVTS][nCell].bFixPointers=true;

	if( m_TitleCells[nVTS][nCell].iMode!=CELLBASED)
	{
		csAux.Format(_T("VTS %02d: Stripping Cell VID/CID: %02d/%02d --> %02d/%02d"),nVTS,VID,CID,NVID,NCID);
		MyLog(csAux);
	}

	for (k=1,m_nVobin=1;k<10;k++)
	{
		i64sectors+=(m_i64VOBsize[nVTS][k]/2048);
		if (i64IniSec<i64sectors)
		{
			i64sectors-=(m_i64VOBsize[nVTS][k]/2048);
			m_nVobin=k;
			k=20;
		}
	}

	csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
	m_csFin=m_csInputPath+ '\\' +csAux;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}
	fseek(m_Fin, (long) ((i64IniSec-i64sectors)*2048), SEEK_SET);

	ilastpack=0;

	if (LOGSTRIP && m_bLog)
	{
		flog=fopen("C:\\cell_strip.log","w");
		fprintf(flog, "CELL %d/%d\n", VID,CID ); 
		fflush(flog);
	}
////////////////////////////////////////////////////////////////
////////////// Check which substreams have to be removed
////////////// And fill the array of bools bSubsStrip & bAudioStrip
////////////////////////////////////////////////////////////////
	for (nAA=0;nAA<8;nAA++) bKeep[nAA]=bStrip[nAA]=false;

	for (nA=0; nA<m_nAudio[nVTS]; nA++)
	{
		AudStatus0=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nA*2+0x0c];
		nAA=AudStatus0 & 0x07;
		if (AudStatus0 & 0x80)
		{
			if ( m_iIdTAudioStrip[nVTS][nA][nT]!=0 )
				bStrip[nAA]=true;
			else
				bKeep[nAA]=true;
		}
	}
	for (nAA=0; nAA<8; nAA++)
	{
		bAudioStrip[nAA]=true; // default strip
		if (bKeep[nAA]==true) bAudioStrip[nAA]=false;
//		if (bKeep[nAA]==true && bStrip[nAA]==true ) 
//			bAudioStrip[nAA]=false;
	}

/// Now the Subs
	for (nSS=0;nSS<32;nSS++) bKeep[nSS]=bStrip[nSS]=false;
	for (nS=0; nS<m_nSubs[nVTS]; nS++)
	{
		SubStatus0=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nS*4+0x1c+0];
		SubStatus1=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nS*4+0x1c+1];
		SubStatus2=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nS*4+0x1c+2];
		SubStatus3=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nS*4+0x1c+3];
		b43=true; bWI=false;
		if (m_iVideoAttr[nVTS] & 0x400)	{b43=false; bWI=true;}
		bLB=false; bPS=false;
		if (bWI && !(m_iVideoAttr[nVTS] & 0x100)) bLB=true;
		if (bWI && !(m_iVideoAttr[nVTS] & 0x200)) bPS=true;
		if (SubStatus0 & 0x80)
		{
			if ( m_iIdTSubsStrip[nVTS][nS][nT]!=0 )
			{
				nSS=SubStatus0 & 0x1F;
				if (b43) bStrip[nSS]=true;
				nSS=SubStatus1 & 0x1F;
				if (bWI) bStrip[nSS]=true;
				nSS=SubStatus2 & 0x1F;
				if (bLB) bStrip[nSS]=true;
				nSS=SubStatus3 & 0x1F;
				if (bPS) bStrip[nSS]=true;
			}
			else
			{
				nSS=SubStatus0 & 0x1F;
				if (b43) bKeep[nSS]=true;
				nSS=SubStatus1 & 0x1F;
				if (bWI) bKeep[nSS]=true;
				nSS=SubStatus2 & 0x1F;
				if (bLB) bKeep[nSS]=true;
				nSS=SubStatus3 & 0x1F;
				if (bPS) bKeep[nSS]=true;
			}
		}
	}
	for (nSS=0;nSS<32;nSS++)
	for (nSS=0;nSS<32;nSS++) 
	{
		bSubsStrip[nSS]=true;	// default strip
		if (bKeep[nSS]==true) bSubsStrip[nSS]=false;
//		if (bKeep[nSS]==true && bStrip[nSS]==true ) 
//			bSubsStrip[nSS]=false;
	}
////////////////////////////////////////////////////////////////
////////////// Done: Arrays of bools bSubsStrip & bAudioStrip filled
////////////////////////////////////////////////////////////////

	for (i64=0;i64< (i64EndSec-i64IniSec+1) && m_bInProcess==true;i64+=(ilastpack+1))
	{

		if (LOGSTRIP && m_bLog)
		{
			fprintf(flog, "LBA %I64d:\n", i64+i64IniSec);
			fflush(flog);
		}
		if ((i64%MODUPDATEVOBU) == 0)
			UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA), true);
////////////////////////////////////////////////////////////////
//		read a VOBU completely into memory
////////////////////////////////////////////////////////////////
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			if (m_Fin!=NULL) fclose (m_Fin);
			m_nVobin++;
			csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
			m_csFin=m_csInputPath+ '\\' +csAux;
			m_Fin=fopen(m_csFin,"rb");
			if (readbuffer(m_buffer,m_Fin)!=2048)
			{
				MyErrorLog_Box("Input error: Reached end of VOB too early");
				m_bInProcess=false;
				return;
			}
		}
		if (IsSynch(m_buffer) != true)
		{
			MyErrorLog_Box("Error reading input VOB: Unsynchronized");
			m_bInProcess=false;
			return;
		}
		if (!IsNav(m_buffer))
		{
			MyErrorLog_Box("Input error: Not found a nav pack where it should be");
			m_bInProcess=false;
			return;
		}

		ilastpack= GetNbytes(4,&m_buffer[0x40f]);
		if (ilastpack >= MAXPACKSPERVOBU-1 )
		{
			MyErrorLog_Box("Input error: VOBU too large");
			m_bInProcess=false;
			return;
		}

		if (LOGSTRIP && m_bLog)
		{
			fprintf(flog, "  VOBU length: %d\n", ilastpack);
			fflush(flog);
		}

		for (j=1 ; j<ilastpack+1 && m_bInProcess; j++)
		{
			if (readbuffer(&m_buffer[2048*j],m_Fin)!=2048)
			{
				if (m_Fin!=NULL) fclose (m_Fin);
				m_nVobin++;
				csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
				m_csFin=m_csInputPath+ '\\' +csAux;
				m_Fin=fopen(m_csFin,"rb");

				if (readbuffer(&m_buffer[2048*j],m_Fin)!=2048)
				{
					MyErrorLog_Box("Input error: Reached end of VOB too early");
					m_bInProcess=false;
					return;
				}
				if (IsSynch(&m_buffer[2048*j]) != true)
				{
					MyErrorLog_Box("Error reading input VOB: Unsynchronized");
					m_bInProcess=false;
					return;
				}
			}
		}

		if (LOGSTRIP && m_bLog)
		{
			fprintf(flog, "  VOBU loaded\n");
			fflush(flog);
		}
////////////////////////////////////////////////////////////////
//Adjust last and references pointers, based in original ones
////////////////////////////////////////////////////////////////
		i64auxp1=GetNbytes(4,&m_buffer[0x40f]);
		i64auxp2=GetNbytes(4,&m_buffer[0x413]);
		i64auxp3=GetNbytes(4,&m_buffer[0x417]);
		i64auxp4=GetNbytes(4,&m_buffer[0x41B]);

		for (j=1 ; j<ilastpack+1 && m_bInProcess; j++)
		{
			bKeepPack=true;
			if (IsAudio(&m_buffer[2048*j]) )
			{
				if ( bAudioStrip[getAudId(&m_buffer[2048*j]) & 0x07]) bKeepPack=false;
			}
/* Old method
				for (nA=0; nA<m_nAudio[nVTS] && bKeepPack ;nA++)
					 if ( m_iIdTAudioStrip[nVTS][nA][nT]!=0 &&
							getAudId(&m_buffer[2048*j]) == (m_iIdTAudio[nVTS][nA][nT]+ m_iAddIdAudio[nVTS][nA]))
						bKeepPack=false;
			}
*/
			if (IsSubs(&m_buffer[2048*j]) )
			{
				if ( bSubsStrip[getSubId(&m_buffer[2048*j]) & 0x1F]) bKeepPack=false;
			}
/* Old method
				for (nS=0; nS<m_nSubs[nVTS] && bKeepPack ;nS++)
				{
					if ( m_iIdTSubsStrip[nVTS][nS][nT]!=0)
					{
		 				SubStatus0=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nS*4+0x1c+0];
						SubStatus1=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nS*4+0x1c+1];
						SubStatus2=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nS*4+0x1c+2];
						SubStatus3=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nS*4+0x1c+3];
						b43=true; bWI=false;
						if (m_iVideoAttr[nVTS] & 0x400)	{b43=false; bWI=true;}
						bLB=false; bPS=false;
						if (bWI && !(m_iVideoAttr[nVTS] & 0x100)) bLB=true;
						if (bWI && !(m_iVideoAttr[nVTS] & 0x200)) bPS=true;
						if (SubStatus0 & 0x80)
						{
							nSS=SubStatus0 & 0x1F;
							if (b43 && getSubId(&m_buffer[2048*j])==(nSS+0x20) ) 
								bKeepPack=false;
							nSS=SubStatus1 & 0x1F;
							if (bWI && getSubId(&m_buffer[2048*j])==(nSS+0x20) ) 
								bKeepPack=false;
							nSS=SubStatus2 & 0x1F;
							if (bLB && getSubId(&m_buffer[2048*j])==(nSS+0x20) ) 
								bKeepPack=false;
							nSS=SubStatus3 & 0x1F;
							if (bPS && getSubId(&m_buffer[2048*j])==(nSS+0x20) ) 
								bKeepPack=false;
						}
					}
				}
			}
*/
			if (!bKeepPack)
			{
				i64aux=GetNbytes(4,&m_buffer[0x40f]);
				if ( j< i64auxp1+1)
					Put4bytes( i64aux-1, &m_buffer[0x40f]);
				i64aux=GetNbytes(4,&m_buffer[0x413]);
				if ( j< i64auxp2+1)
					Put4bytes( i64aux-1, &m_buffer[0x413]);
				i64aux=GetNbytes(4,&m_buffer[0x417]);
				if ( j< i64auxp3+1)
					Put4bytes( i64aux-1, &m_buffer[0x417]);
				i64aux=GetNbytes(4,&m_buffer[0x41B]);
				if ( j< i64auxp4+1)
					Put4bytes( i64aux-1, &m_buffer[0x41B]);
			}
		}
////////////////////////////////////////////////////////////////
//Write VOBU
////////////////////////////////////////////////////////////////
		if (LOGSTRIP && m_bLog)
		{
			fprintf(flog, "  VOBU stripped\n");
			fflush(flog);
		}


		for (j=0 ; j<ilastpack+1 && m_bInProcess; j++)
		{
			if (IsNav(&m_buffer[2048*j]))
			{
				for (nS=0; nS<m_nSubs[nVTS];nS++)
					 if ( m_iIdTSubsStrip[nVTS][nS][nT]==1) Put4bytes(0, &m_buffer[0x5a9+nS*4]);
				for (nA=0; nA<m_nAudio[nVTS];nA++)
					 if ( m_iIdTAudioStrip[nVTS][nA][nT]==1) Put2bytes(0, &m_buffer[0x599+nA*2]);

				ModifyCID (&m_buffer[2048*j],NVID,NCID);
				WritePack(&m_buffer[2048*j],nVTS);
			}
			else if (IsAudio(&m_buffer[2048*j]) )
			{
				bKeepPack=true;
				if ( bAudioStrip[getAudId(&m_buffer[2048*j]) & 0x07]) bKeepPack=false;

/*				for (nA=0; nA<m_nAudio[nVTS] && bKeepPack;nA++)
					 if ( m_iIdTAudioStrip[nVTS][nA][nT]!=0 &&
							getAudId(&m_buffer[2048*j]) == (m_iIdTAudio[nVTS][nA][nT]+m_iAddIdAudio[nVTS][nA]))
					bKeepPack=false;
*/
				if (bKeepPack) 
					WritePack(&m_buffer[2048*j],nVTS);
			}
			else if (IsSubs(&m_buffer[2048*j]) )
			{
				bKeepPack=true;
				if ( bSubsStrip[getSubId(&m_buffer[2048*j]) & 0x1F]) bKeepPack=false;

/*				for (nS=0; nS<m_nSubs[nVTS] && bKeepPack ;nS++)
				{
					if ( m_iIdTSubsStrip[nVTS][nS][nT]!=0)
					{
		 				SubStatus0=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nS*4+0x1c+0];
						SubStatus1=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nS*4+0x1c+1];
						SubStatus2=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nS*4+0x1c+2];
						SubStatus3=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nS*4+0x1c+3];
						b43=true; bWI=false;
						if (m_iVideoAttr[nVTS] & 0x400)	{b43=false; bWI=true;}
						bLB=false; bPS=false;
						if (bWI && !(m_iVideoAttr[nVTS] & 0x100)) bLB=true;
						if (bWI && !(m_iVideoAttr[nVTS] & 0x200)) bPS=true;
						if (SubStatus0 & 0x80)
						{
							nSS=SubStatus0 & 0x1F;
							if (b43 && getSubId(&m_buffer[2048*j])==(nSS+0x20) ) 
								bKeepPack=false;
							nSS=SubStatus1 & 0x1F;
							if (bWI && getSubId(&m_buffer[2048*j])==(nSS+0x20) ) 
								bKeepPack=false;
							nSS=SubStatus2 & 0x1F;
							if (bLB && getSubId(&m_buffer[2048*j])==(nSS+0x20) ) 
								bKeepPack=false;
							nSS=SubStatus3 & 0x1F;
							if (bPS && getSubId(&m_buffer[2048*j])==(nSS+0x20) ) 
								bKeepPack=false;
						}
					}
				}
*/
				if (bKeepPack) 
					WritePack(&m_buffer[2048*j],nVTS);
			}
			else
				WritePack(&m_buffer[2048*j],nVTS);
		}
		if (LOGSTRIP && m_bLog)
		{
			fprintf(flog, "  VOBU written\n");
			fflush(flog);
		}

	}
	if (m_Fin!=NULL) fclose (m_Fin);
	m_Fin=NULL;
	if (LOGSTRIP && m_bLog && flog!=NULL)
		fclose(flog);

}


void CVobBlankerApp::TitleCellReplace(int nVTS,int nCell, CWnd* pDlg)
{
	int k,nT;
	__int64 i64sectors, i64IniSec,i64EndSec,i64;
	int VobRep,CellRep;
	int VID,CID,NVID,NCID;
	bool bAlreadyNav, bWarning;
	int LastCellid,LastVobid;
	CString csAux,csAux1;
	DWORD dwVOBUDuration;
	int nPads;

	__int64 i64TotRsize,i64RVOBsize[10];
	struct  _stati64 statbuf;

//  Locate the cell
	i64IniSec=m_TitleCells[nVTS][nCell].i64IniSecAux;
	i64EndSec=m_TitleCells[nVTS][nCell].i64EndSecAux;
	VID=m_TitleCells[nVTS][nCell].VID;
	CID=m_TitleCells[nVTS][nCell].CID;
	NVID=m_TitleCells[nVTS][nCell].NVID;
	NCID=m_TitleCells[nVTS][nCell].NCID;
	nT=m_TitleCells[nVTS][nCell].nT;

// Fill Replacing VOB Set Sizes
	i64TotRsize=0;
	for (k=1; k<10; k++)
	{
		csAux1=m_csReplace[nVTS][nT];
		csAux=csAux1.Left(csAux1.GetLength()-5);
		csAux1.Format(_T("%d.VOB"),k);
		m_csFin=csAux+csAux1;
		if (_stati64 ( m_csFin, &statbuf)==0)
		{
			i64RVOBsize[k]= statbuf.st_size;
			i64TotRsize+=i64RVOBsize[k];
		}
		else
		{
			i64RVOBsize[k]= 0;
		}
	}


	if( i64IniSec <0 || i64EndSec <=0 )
	{
// Extra cells, because replacing title has less cells than the original
		csAux.Format(_T("VTS %02d: Replacing PGC-> Blanking Cell VID/CID: %02d/%02d --> %02d/%02d"),nVTS,VID,CID,NVID,NCID);
		MyLog(csAux);
		OutputBlankCell(nVTS,NVID,NCID);
		return;
	}

	i64sectors=0;
	for (k=1,m_nVobin=1;k<10;k++)
	{
		i64sectors+=(i64RVOBsize[k]/2048);
		if (i64IniSec<i64sectors)
		{
			i64sectors-=(i64RVOBsize[k]/2048);
			m_nVobin=k;
			k=20;
		}
	}

	csAux1=m_csReplace[nVTS][nT];
	csAux=csAux1.Left(csAux1.GetLength()-5);
	csAux1.Format(_T("%d.VOB"),m_nVobin);
	m_csFin=csAux+csAux1;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}

	csAux.Format(_T("VTS %02d: Replacing PGC-> Replacing Cell VID/CID: %02d/%02d --> %02d/%02d"),nVTS,VID,CID,NVID,NCID);
	MyLog(csAux);

	fseek(m_Fin, (long) ((i64IniSec-i64sectors)*2048), SEEK_SET);

	LastCellid=LastVobid=-1;

	bWarning=false;
	m_iFixDuration=0;

	nPads=0;
	for (i64=0,bAlreadyNav=false;i64< (i64EndSec-i64IniSec+1) && m_bInProcess==true;i64++)
	{
// Seems compatible with ADDOFFDURATION...if (m_bCheckElapsed) m_iFixDuration=GETOFFDURATION;
	//readpack
		if ((i64%MODUPDATE) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA), true);
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			if (m_Fin!=NULL) fclose (m_Fin);
			m_nVobin++;
			csAux1=m_csReplace[nVTS][nT];
			csAux=csAux1.Left(csAux1.GetLength()-5);
			csAux1.Format(_T("%d.VOB"),m_nVobin);
			m_csFin=csAux+csAux1;
			m_Fin=fopen(m_csFin,"rb");
			if (readbuffer(m_buffer,m_Fin)!=2048)
			{
				MyErrorLog_Box("Input error: Reached end of VOB too early");
				m_bInProcess=false;
				return;
			}
		}
		if (m_bInProcess==true && IsSynch(m_buffer) != true)
		{
			if (nPads==0)
				MyLog("    WARNING: Packs unsynchronized. Skipping packs...",ORANGE); 
			nPads++;
		}
		else if (m_bInProcess==true)
		{
			if (IsNav(m_buffer))
			{
				bAlreadyNav=true;
				CellRep=m_buffer[0x422];
				VobRep=m_buffer[0x41F]*256+m_buffer[0x420];
				if (LastCellid==-1)
				{
					LastCellid=CellRep;
					LastVobid=VobRep;

				}

				if (CellRep!=LastCellid || VobRep!=LastVobid)
				{
					if (!bWarning)
					{
						MyLog("     NOTE: Number of Cells higher than one. Continuing with same cell VID/CID",CIAN15);
						m_nNotes++;
					}
					bWarning=true;

					k=m_ANavinfo.GetSize()-1;
					if (k>=0)
					{
						m_iFixDuration=ADDOFFDURATION;

						m_dwOffDuration=m_ANavinfo[k].dwDuration;
						dwVOBUDuration=(m_ANavinfo[k].iPTS1-m_ANavinfo[k].iPTS0)/(m_ticsperframe);
						dwVOBUDuration=Dec2BCD(dwVOBUDuration);
						dwVOBUDuration=dwVOBUDuration|(m_dwOffDuration & 0xc0);
						m_dwOffDuration=AddDuration(m_dwOffDuration,dwVOBUDuration);
					}
				}
				LastVobid=VobRep;
				LastCellid=CellRep;
				ModifyCID (m_buffer,NVID, NCID);
				CleanILV(m_buffer);
			}
			if( bAlreadyNav)
				WritePack(m_buffer,nVTS);
		} // In process
	} // For

	if (nPads!=0)
	{
		csAux.Format(_T("    A total of %d packs have been skipped"),nPads);
		MyLog(csAux,ORANGE);
	}

	if (!bAlreadyNav)
	{
		MyLog("    WARNING: No Navs found!: outputting a blank cell",ORANGE); 
		m_nWarnings++;
		OutputBlankCell(nVTS,NVID,NCID);
	}

	if (m_Fin!=NULL) fclose (m_Fin);
	m_Fin=NULL;
}

///////////////////////////////////////////////////////////////////////////
///             Cell Methods, called in Second phase   ////////////////////
///             Motion 2 Still methods                 ////////////////////
///////////////////////////////////////////////////////////////////////////

int CVobBlankerApp::ExtractTitleIFrame(int nVTS, int nCell, int nVobin)
{
// Returns the number of sectors of the m_IFrame
	__int64 i64;
	int VobId,CellId;
	int iEnd;
	int i, j, iFindex, iEndIFrame;
	int start,nbytes;
	bool bFirstVideo;
	CString csAux;

//  Locate the title cell
	VobId=m_TitleCells[nVTS][nCell].VID;
	CellId=m_TitleCells[nVTS][nCell].CID;

// Read the Nav-Pack
	if (readbuffer(m_buffer,m_Fin)!=2048)
	{
		MyErrorLog_Box("Input error: Reached end of VOB too early");
		return -1;
	}
	if (IsSynch(m_buffer) != true)
	{
		MyErrorLog_Box("Error reading input VOB: Unsynchronized");
		return -1;
	}
	if (!IsNav(m_buffer))
	{
		MyErrorLog_Box("Input error: Not found a nav pack where it should be");
		return -1;
	}

	iEnd=GetNbytes(4,&m_buffer[0x413]);

	m_IFrame= new uchar[(iEnd+1)*2048];

	iFindex=0;
	iEndIFrame=0;
	bFirstVideo=true;
	for (i64=0; i64< iEnd ; i64++)
	{
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			if (m_Fin !=NULL) fclose (m_Fin);
			nVobin++;
			csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, nVobin);
			m_csFin=m_csInputPath+ '\\' +csAux;
			m_Fin=fopen(m_csFin,"rb");
			if (m_Fin ==NULL)
			{
				MyErrorLog_Box("Error opening input VOB: "+m_csFin);
				delete [] m_IFrame;
				return -1;
			}
			if (readbuffer(m_buffer,m_Fin)!=2048)
			{
				MyErrorLog_Box("Input error: Reached end of VOB too early");
				delete [] m_IFrame;
				return -1;
			}
		}
		if (IsVideo(m_buffer))
		{
			start=0x17+m_buffer[0x16];
			nbytes=m_buffer[0x12]*256+m_buffer[0x13]+0x14-start;
			for (i=0;i<2048;i++)
			{
				m_IFrame[iFindex+i]=m_buffer[i];
			}
			if (bFirstVideo)
			{
				bFirstVideo=false;
				// Reset temperal sequence 
				for (j=start; j<2044 ; j++)
					if (m_IFrame[j]   == 0 && m_IFrame[j+1] == 0 && 
						m_IFrame[j+2] == 1 && m_IFrame[j+3] == 0 )
					{
						m_IFrame[j+4]=0;
						m_IFrame[j+5]=m_IFrame[j+5] & 0x3F;
						j=2048;
					}
	
			}
			if (i64==(iEnd-1))
			{
				for (j=start,iEndIFrame=0; j<2048-3; j++)
				{
					if (m_buffer[j]   == 0 && m_buffer[j+1] == 0 &&
						m_buffer[j+2] == 1 && ( m_buffer[j+3] == 0 || m_buffer[j+3] == 0xB7 ) )
					{
						iEndIFrame=j;
						Put4bytes(0x000001B7, &m_IFrame[iFindex+iEndIFrame]);
						if ((iEndIFrame+4)<(2048-6))
						{
							Put4bytes(0x000001BE, &m_IFrame[iFindex+iEndIFrame+4]);
							Put2bytes(2048-iEndIFrame-6-4, &m_IFrame[iFindex+iEndIFrame+8]);
							for (i=iEndIFrame+6+4; i<2048; i++)
								m_IFrame[iFindex+i]=0xFF;
						}
						else
						{
							for (i=iEndIFrame+4; i<2048; i++)
								m_IFrame[iFindex+i]=0x00;
						}
						Put2bytes(iEndIFrame+4-0x14, &m_IFrame[iFindex+0x12]);
						j=2048;
					}
				}
				if (!iEndIFrame )
				{
					csAux.Format(_T("     WARNING: No picture sequence found in selected VOBU of cell %d. Adding a New pack."),nCell+1);
					MyLog(csAux,ORANGE);
					m_nWarnings++;
					// Add a full padd pack
					iFindex+=2048;
					for (i=0;i<64;i++)
						m_IFrame[iFindex+i]=EndSeqPlusPadding[i];
					for (i=64;i<2048;i++)
						m_IFrame[iFindex+i]=0xFF;
				}
			}
			iFindex+=2048;
		}
	}
	return iFindex/2048;
}

void CVobBlankerApp::TitleCellExplore(int nVTS, int nCell)
{
	__int64 i64IniSec, i64EndSec, i64sectors;
	int VobId,CellId;
	int k;
	CString csAux;
	int VOBUSector, iIniVOBU,nVOBUS;


//  Locate the title cell
	i64IniSec=m_TitleCells[nVTS][nCell].i64IniSecCell;
	i64EndSec=m_TitleCells[nVTS][nCell].i64EndSecCell;
	VobId=m_TitleCells[nVTS][nCell].VID;
	CellId=m_TitleCells[nVTS][nCell].CID;
	nVOBUS=m_TitleCells[nVTS][nCell].nVOBUS;
	iIniVOBU=m_TitleCells[nVTS][nCell].iIniVOBU;

//////////////////////////
//  IniSector data
//////////////////////////
	i64sectors=0;
	for (k=1,m_nVobin=1;k<10;k++)
	{
		i64sectors+=(m_i64VOBsize[nVTS][k]/2048);
		if (i64IniSec<i64sectors)
		{
			i64sectors-=(m_i64VOBsize[nVTS][k]/2048);
			m_nVobin=k;
			k=20;
		}
	}

	csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
	m_csFin=m_csInputPath+ '\\' +csAux;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}
	fseek(m_Fin, (long) ((i64IniSec-i64sectors)*2048), SEEK_SET);

	if (readbuffer(m_buffer,m_Fin)!=2048)
	{
//		MyErrorBox("Input error: Reached end of VOB too early");
		if (m_Fin !=NULL) { fclose (m_Fin); m_Fin=NULL;}
		return;
	}
	if (!IsNav(m_buffer))
	{
//		MyErrorBox("Input error: Not found a NAv where it should be");
		if (m_Fin !=NULL) { fclose (m_Fin); m_Fin=NULL;}
		return;
	}

	m_TitleCells[nVTS][nCell].i64IniButtons=i64IniSec*2048;
	m_TitleCells[nVTS][nCell].i64IniIFSize=GetNbytes(4,&m_buffer[0x413])*2048;
	fclose (m_Fin);
	m_Fin=NULL;

//////////////////////////
//  MidSector data
//////////////////////////
	VOBUSector=GetNbytes(4, &m_pIFO[nVTS][m_VTS_VOBU_ADMAP[nVTS] + 4 +4*(iIniVOBU+nVOBUS/2-1)]);
	m_TitleCells[nVTS][nCell].i64MidButtons=((__int64)VOBUSector)*2048;

	i64sectors=0;
	for (k=1,m_nVobin=1;k<10;k++)
	{
		i64sectors+=(m_i64VOBsize[nVTS][k]/2048);
		if (VOBUSector<i64sectors)
		{
			i64sectors-=(m_i64VOBsize[nVTS][k]/2048);
			m_nVobin=k;
			k=20;
		}
	}

	csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
	m_csFin=m_csInputPath+ '\\' +csAux;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}

	fseek(m_Fin, (long) ((VOBUSector-i64sectors)*2048), SEEK_SET);

	if (readbuffer(m_buffer,m_Fin)!=2048)
	{
//		MyErrorBox("Input error: Reached end of VOB too early");
		if (m_Fin !=NULL) { fclose (m_Fin); m_Fin=NULL;}
		return;
	}
	if (!IsNav(m_buffer))
	{
//		MyErrorBox("Input error: Not found a NAv where it should be");
		if (m_Fin !=NULL) { fclose (m_Fin); m_Fin=NULL;}
		return;
	}

	m_TitleCells[nVTS][nCell].i64MidIFSize=GetNbytes(4,&m_buffer[0x413])*2048;
	fclose (m_Fin);
	m_Fin=NULL;

//////////////////////////
//  EndSector data
//////////////////////////
	VOBUSector=GetNbytes(4, &m_pIFO[nVTS][m_VTS_VOBU_ADMAP[nVTS] + 4 +4*(iIniVOBU+nVOBUS-1)]);
	m_TitleCells[nVTS][nCell].i64EndButtons=((__int64)VOBUSector)*2048;

	i64sectors=0;
	for (k=1,m_nVobin=1;k<10;k++)
	{
		i64sectors+=(m_i64VOBsize[nVTS][k]/2048);
		if (VOBUSector<i64sectors)
		{
			i64sectors-=(m_i64VOBsize[nVTS][k]/2048);
			m_nVobin=k;
			k=20;
		}
	}

	csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
	m_csFin=m_csInputPath+ '\\' +csAux;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}

	fseek(m_Fin, (long) ((VOBUSector-i64sectors)*2048), SEEK_SET);

	if (readbuffer(m_buffer,m_Fin)!=2048)
	{
//		MyErrorBox("Input error: Reached end of VOB too early");
		if (m_Fin !=NULL) { fclose (m_Fin); m_Fin=NULL;}
		return;
	}
	if (!IsNav(m_buffer))
	{
//		MyErrorBox("Input error: Not found a NAv where it should be");
		if (m_Fin !=NULL) { fclose (m_Fin); m_Fin=NULL;}
		return;
	}

	m_TitleCells[nVTS][nCell].i64EndIFSize=GetNbytes(4,&m_buffer[0x413])*2048;
	fclose (m_Fin);
	m_Fin=NULL;

//////////////////////////
//  MaxSector data
//////////////////////////

	m_TitleCells[nVTS][nCell].i64MaxButtons=m_TitleCells[nVTS][nCell].i64IniButtons;
	m_TitleCells[nVTS][nCell].i64MaxIFSize= m_TitleCells[nVTS][nCell].i64IniIFSize;

	if (m_TitleCells[nVTS][nCell].i64MidIFSize > m_TitleCells[nVTS][nCell].i64MaxIFSize)
	{
		m_TitleCells[nVTS][nCell].i64MaxButtons=m_TitleCells[nVTS][nCell].i64MidButtons;
		m_TitleCells[nVTS][nCell].i64MaxIFSize= m_TitleCells[nVTS][nCell].i64MidIFSize;
	}
	if (m_TitleCells[nVTS][nCell].i64EndIFSize > m_TitleCells[nVTS][nCell].i64MaxIFSize)
	{
		m_TitleCells[nVTS][nCell].i64MaxButtons=m_TitleCells[nVTS][nCell].i64EndButtons;
		m_TitleCells[nVTS][nCell].i64MaxIFSize= m_TitleCells[nVTS][nCell].i64EndIFSize;
	}
}

void CVobBlankerApp::TitleCellStill(int nVTS, int nCell, bool bAudio, __int64 i64Sector, CWnd* pDlg)
{
	int i,j,k;
	__int64 i64IniSec,i64EndSec,i64;
	CString csAux,csAux2;
	bool bMyCell;
	int VID,CID,NVID,NCID;
	__int64 i64auxp1,i64auxp2;
	int ilastpack, ilastpack_old;
	bool bFirstVobu, bLastVobu;
	int nPacksIFrame;
	uint64 scr,scr_new;
	int nInserted,nToBeInserted;
	bool bInserting;
	int scr_ext;
	int iFormat;
	UINT vobu_s_ptm,vobu_e_ptm,vobu_se_e_ptm, videopts, videodts;
//	__int64 VOBUSector, i64LastSector;
	__int64 i64SecIniButtons,i64SecEndButtons,i64SecMidButtons,i64SecMaxButtons;
//	int EndADMAPSector;
//	int nPacksStart,nPacksEnd;
	int nAud[8],iAud;
	int nPacksWritten;
	__int64 i64SubP;
	bool bSubsWarned, bSecondVobu;
	__int64 i64sectors;
	bool bExternalFile;
	int nButtons;   // Note BOVs are not supported, but there is part of code inside...



//i64Sector values:
// -1: First GOP
// -2: Middle GOP 
// -3: Last GOP 
// -4: The largest 
// -5: Use global default.
// >=0: Exact (selected) sector, relative to ini of cell.

	bExternalFile=false;

	if (i64Sector==-5) i64Sector=(m_iIFrameMode+1)*(-1);

//  Locate the title cell
//	i64sectors=0;
	i64IniSec=m_TitleCells[nVTS][nCell].i64IniSecCell;
	i64EndSec=m_TitleCells[nVTS][nCell].i64EndSecCell;
	VID=m_TitleCells[nVTS][nCell].VID;
	CID=m_TitleCells[nVTS][nCell].CID;
	NVID=m_TitleCells[nVTS][nCell].NVID;
	NCID=m_TitleCells[nVTS][nCell].NCID;

	if( m_TitleCells[nVTS][nCell].iMode!=CELLBASED)
	{
		if (bAudio)
			csAux2="with";
		else
			csAux2="w/o";

		csAux.Format(_T("VTS %02d: Motion2still %s audio Cell VID/CID: %02d/%02d --> %02d/%02d"),nVTS,csAux2,VID,CID,NVID,NCID);
		MyLog(csAux);
	}

// Selecting the I-Frame
	i64SecIniButtons=m_TitleCells[nVTS][nCell].i64IniButtons/2048 - i64IniSec;
	i64SecMidButtons=m_TitleCells[nVTS][nCell].i64MidButtons/2048 - i64IniSec;
	i64SecEndButtons=m_TitleCells[nVTS][nCell].i64EndButtons/2048 - i64IniSec;
	i64SecMaxButtons=m_TitleCells[nVTS][nCell].i64MaxButtons/2048 - i64IniSec;

	if (i64Sector==-1)
		i64Sector=i64SecIniButtons;

	if (i64Sector==-2)
	{
		if (m_TitleCells[nVTS][nCell].i64MidIFSize != 0)
			i64Sector=i64SecMidButtons;
		else
			i64Sector=i64SecIniButtons;
	}
	if (i64Sector==-3)
	{
		if (m_TitleCells[nVTS][nCell].i64EndIFSize != 0)
			i64Sector=i64SecEndButtons;
		else
			i64Sector=i64SecIniButtons;
	}
	if (i64Sector==-4)
	{
		if (m_TitleCells[nVTS][nCell].i64MaxIFSize != 0)
			i64Sector=i64SecMaxButtons;
		else
			i64Sector=i64SecIniButtons;
	}
	if (i64Sector==-6)
	{
		i64Sector=0;
		bExternalFile=true;
	}

	csAux.Format(_T("     NOTE: Selected sector (relative to cell start) %I64d in cell: %d"),i64Sector,nCell+1 );
	MyLog(csAux,CIAN15);
	m_nNotes++;

///////////////////////////////////////////////////////////////////////////
// Extracting the I-Frame
///////////////////////////////////////////////////////////////////////////
// Calculate i64sectors & m_nVobin: Starting point of VOB file
	i64sectors=0;
	i64IniSec=m_TitleCells[nVTS][nCell].i64IniSecCell;

	for (k=1,m_nVobin=1;k<10;k++)
	{
		i64sectors+=(m_i64VOBsize[nVTS][k]/2048);
		if ((i64IniSec+i64Sector)<i64sectors)
		{
			i64sectors-=(m_i64VOBsize[nVTS][k]/2048);
			m_nVobin=k;
			k=20;
		}
	}

// Extract the I-Frame
	if (bExternalFile)
	{
		m_csFin=m_ACellStillinfo[m_TitleCells[nVTS][nCell].indexStill].csFileStill;
// Open External file
		m_Fin=fopen(m_csFin,"rb");
		if (m_Fin ==NULL)
		{
			MyErrorLog_Box("Error opening input VOB: "+m_csFin);
			m_bInProcess=false;
			return;
		}
		fseek(m_Fin, (long) (i64Sector*2048), SEEK_SET);
		nPacksIFrame=ExtractExternalIFrame(i64Sector);
	}
	else
	{
// Open title file	

		csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
		m_csFin=m_csInputPath+ '\\' +csAux;
		m_Fin=fopen(m_csFin,"rb");
		if (m_Fin ==NULL)
		{
			MyErrorLog_Box("Error opening input VOB: "+m_csFin);
			m_bInProcess=false;
			return;
		}

		fseek(m_Fin, (long) ((i64IniSec-i64sectors+i64Sector)*2048), SEEK_SET);

		nPacksIFrame=ExtractTitleIFrame(nVTS, nCell, m_nVobin);
	}

	if (nPacksIFrame<0)
	{
		MyErrorLog_Box("Extracting IFrame process failed: Aborting");
		m_bInProcess=false;
		if (m_Fin !=NULL) fclose (m_Fin); 
		return;
	}
	if (nPacksIFrame==0)
	{
		csAux.Format(_T("     WARNING: No I Frame found in cell: %d"),nCell+1);
		MyLog(csAux,ORANGE);
		m_nWarnings++;
	}

	if (bAudio && i64SecIniButtons !=0) 
	{
		csAux.Format(_T("     WARNING: Truncating audio. Buttons start in the middle of cell: %d"),nCell+1);
		MyLog(csAux,ORANGE);
		m_nWarnings++;
	}

// Mark as closed GOP
	SetClosedGOP(m_IFrame);

//////////////////////////////////////////////////////////////////////
// Rewind
//////////////////////////////////////////////////////////////////////
	fclose (m_Fin);

	csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
	m_csFin=m_csInputPath+ '\\' +csAux;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}
	fseek(m_Fin, (long) ((i64IniSec-i64sectors)*2048), SEEK_SET);

	if (bAudio) MyLog("     Opened cell for reading: All Navs have to be corrected, so this will take a while...");

	bFirstVobu=true;
	bLastVobu=false;
	bSecondVobu=false;
	bSubsWarned=false;
	ilastpack=ilastpack_old=0;
	nPacksWritten=0;
	for (i64=i64SecIniButtons,bMyCell=true;i64< (i64EndSec-i64IniSec+1) && m_bInProcess==true;i64+=(ilastpack+1))
	{
		if ((i64%MODUPDATEVOBU) == 0) UpdateProgress(pDlg, (int)((100*m_i64OutputLBA)/m_i64TotalLBA), true);

// Read VOBU
		for (j=0 ; j<ilastpack+1 && m_bInProcess; j++)
		{
			if (readbuffer(&m_buffer[2048*j],m_Fin)!=2048)
			{
				if (m_Fin !=NULL) { fclose (m_Fin); m_Fin=NULL;}
				m_nVobin++;
				csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobin);
				m_csFin=m_csInputPath+ '\\' +csAux;
				m_Fin=fopen(m_csFin,"rb");
				if (readbuffer(&m_buffer[2048*j],m_Fin)!=2048)
				{
					MyErrorLog_Box("Input error: Reached end of VOB too early");
					m_bInProcess=false;
					delete [] m_IFrame;
					if (m_Fin !=NULL) { fclose (m_Fin); m_Fin=NULL;}
					return;
				}
			}
			if (IsSynch(m_buffer) != true)
			{
				MyErrorLog_Box("Error reading input VOB: Unsynchronized");
				m_bInProcess=false;
				delete [] m_IFrame;
				if (m_Fin !=NULL) { fclose (m_Fin); m_Fin=NULL;}
				return;
			}
			if (j==0 && !IsNav(m_buffer))
			{
				MyErrorLog_Box("Input error: Not found a nav pack where it should be");
				m_bInProcess=false;
				delete [] m_IFrame;
				if (m_Fin !=NULL) { fclose (m_Fin); m_Fin=NULL;}
				return;
			}

			if (j==0)
			{
				ilastpack_old=ilastpack;
				ilastpack= GetNbytes(4,&m_buffer[0x40f]);
				if ((ilastpack+i64+1) >= (i64EndSec-i64IniSec+1)) 
					bLastVobu=true;

				if (ilastpack >= MAXPACKSPERVOBU-1 )
				{
					MyErrorLog_Box("Input error: VOBU too large");
					m_bInProcess=false;
					delete [] m_IFrame;
					if (m_Fin !=NULL) fclose (m_Fin); 
					return;
				}
			}

		}
///////////////////////////////////////////////////////////////////
//Adjust Nav pointers
///////////////////////////////////////////////////////////////////
// lastpack
//		i64auxp1=GetNbytes(4,&m_buffer[0x40f]);
// first,second and third ref end
//		i64auxp2=GetNbytes(4,&m_buffer[0x413]);
//		i64auxp3=GetNbytes(4,&m_buffer[0x417]);
//		i64auxp4=GetNbytes(4,&m_buffer[0x41B]);

		if (!bFirstVobu)
		{
			i64auxp1=0;
			Put4bytes(0,&m_buffer[0x413]);
			Put4bytes(0,&m_buffer[0x417]);
			Put4bytes(0,&m_buffer[0x41B]);
			for (j=0;j<8;j++) nAud[j]=0;
			for (j=0 ; j<ilastpack+1 && m_bInProcess; j++)
			{
				if (IsAudio(&m_buffer[2048*j])	&& bAudio)
				{
					i64auxp1++; 
					iAud=getAudId(&m_buffer[2048*j]) &0x7;
					if (nAud[iAud]==0) nAud[iAud]=j;
				}
				else if (IsSubs (&m_buffer[2048*j])) i64auxp1++;
			}
			Put4bytes(i64auxp1,&m_buffer[0x40f]);
			Put4bytes(0,&m_buffer[0x413]);
			Put4bytes(0,&m_buffer[0x417]);
			Put4bytes(0,&m_buffer[0x41B]);

		}
		if (bFirstVobu)
		{
			nButtons= m_buffer[0x9E];
			i64auxp1=i64auxp2=0;
			for (j=0;j<8;j++) nAud[j]=0;
			scr=readscr(m_buffer); // reads nav scr...
			nInserted=0;
			for (j=1, bInserting=true; j<ilastpack+1; j++)
			{
				if ((IsAudio(&m_buffer[2048*j])	&& bAudio) || 
				    (IsSubs (&m_buffer[2048*j])) )
				{
					i64auxp1++;
					if (bInserting)
					{
						scr_new=readscr(m_buffer+j*2048);
						if (scr_new > scr+146)
							nToBeInserted=(int)((scr_new-scr)/147 -1);
						else nToBeInserted=0;
	// First non-nav MUST be a video
						if (nToBeInserted==0 && nInserted==0) nToBeInserted=1;

						if (nInserted+nToBeInserted >= nPacksIFrame)
						{
							nToBeInserted=nPacksIFrame-nInserted;
							bInserting=false;
							i64auxp2+=nToBeInserted;
						}
						else
							i64auxp2+=(nToBeInserted+1);

						nInserted+=nToBeInserted;
						scr=scr_new;
					}
				}
				if (IsAudio(&m_buffer[2048*j])	&& bAudio)
				{
					iAud=getAudId(&m_buffer[2048*j]) &0x7;
					if (nAud[iAud]==0) nAud[iAud]=j;
				}
			}
			if (bInserting)
			{
				nToBeInserted=nPacksIFrame-nInserted;
				nInserted+=nToBeInserted;
				i64auxp2+=nToBeInserted;
				bInserting=false;
			}

			i64auxp1+=nPacksIFrame;
			Put4bytes(i64auxp1,&m_buffer[0x40f]);
			Put4bytes(i64auxp2,&m_buffer[0x413]);
			Put4bytes(0,&m_buffer[0x417]);
			Put4bytes(0,&m_buffer[0x41B]);
		}
// SRI pointers
		Put4bytes(0xBFFFFFFF,&m_buffer[0x4F1]);
		for (i=0;i<19;i++)
			Put4bytes(0x3FFFFFFF,&m_buffer[0x4F5+i*4]);
		Put4bytes(0x3FFFFFFF,&m_buffer[0x541]);
		Put4bytes(0x3FFFFFFF,&m_buffer[0x545]);
		for (i=0;i<19;i++)
			Put4bytes(0x3FFFFFFF,&m_buffer[0x549+i*4]);

		Put4bytes(0xBFFFFFFF,&m_buffer[0x595]);
// Adjust Previous VOBU pointers
		if (!bFirstVobu && bAudio)
		{
			Put4bytes((UINT)0x80000000+(UINT)(ilastpack_old+1),&m_buffer[0x545]);
			Put4bytes((UINT)0x80000000+(UINT)(ilastpack_old+1),&m_buffer[0x549]);
		}
// Adjust Last VOBU pointers
		if (!bLastVobu && bAudio)
		{
			Put4bytes(ilastpack+1,&m_buffer[0x53d]);
			Put4bytes(ilastpack+1,&m_buffer[0x541]);
		}

//  SYNCI audio pointers
		for (i=0;i<8;i++)
		{
			if (!bAudio) Put2bytes(0,&m_buffer[0x599+i*2]);
// Not true, but who needs delay adjustments audio/video in a still?
			if (bAudio)
				Put2bytes(nAud[i],&m_buffer[0x599+i*2]);
		}

//  SYNCI subs pointers
		for (i=0;i<32;i++)
		{
			i64SubP=GetNbytes(4,&m_buffer[0x5a9+4*i]);
			if (i64SubP!=0)
			{
				if (bFirstVobu)
					Put4bytes(0x7FFFFFFF,&m_buffer[0x5a9+4*i]);
				if (!bFirstVobu && bAudio)
					Put4bytes(nPacksWritten | 0x80000000 ,&m_buffer[0x5a9+4*i]);
			}
		}

//////////////////////////////////////////////////////////////////
// Patch SUBS: Deleted
//////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
//Write VOBU
///////////////////////////////////////////////////////////////////
		if (!bFirstVobu && bAudio ) 
		{
			nPacksWritten+=(int)(i64auxp1+1);
			vobu_e_ptm=GetNbytes(4,&m_buffer[0x3d]);
			for (j=0 ; j<ilastpack+1 && m_bInProcess; j++)
			{
//				scr=readscr(m_buffer+j*2048);
//				scr_ext=readscr_ext(m_buffer+j*2048);
				if (IsNav(&m_buffer[2048*j]))
				{
					ModifyCID (&m_buffer[2048*j],NVID,NCID);
					WritePack(&m_buffer[2048*j],nVTS);
				}
				else if (IsAudio(&m_buffer[2048*j])	&& bAudio) 
					WritePack(&m_buffer[2048*j],nVTS);
				else if (IsSubs (&m_buffer[2048*j]))
				{
					// patch subs PTS (I'm blind here..)
//					if (m_buffer[2048*j+0x15] & 0x80) 
//						writepts(&m_buffer[2048*j+0x17],videopts);
					WritePack(&m_buffer[2048*j],nVTS);
				}
			}
		}

		if (bFirstVobu)
		{
			nPacksWritten+=(int)(i64auxp1+1);
			vobu_s_ptm=GetNbytes(4,&m_buffer[0x39]);
			vobu_e_ptm=GetNbytes(4,&m_buffer[0x3d]);
//			vobu_se_e_ptm=GetNbytes(4,&m_buffer[0x41]);

			iFormat=(m_iVideoAttr[nVTS] & 0x1000) >> 12;
			if (iFormat==NTSC) 
			{
				vobu_se_e_ptm=vobu_s_ptm+3003;
				videopts=vobu_s_ptm;
				videodts=vobu_s_ptm-3003;
			}
			else
			{
				vobu_se_e_ptm=vobu_s_ptm+3600;
				videopts=vobu_s_ptm;
				videodts=vobu_s_ptm-3600;
			}
			Put4bytes(vobu_se_e_ptm,&m_buffer[0x41]);
			if (!bAudio) 
			{
				vobu_e_ptm=vobu_se_e_ptm;
				Put4bytes(vobu_e_ptm,&m_buffer[0x3d]);
			}

// Clear elapsed time
			if (!bAudio)
			{
				if (iFormat==NTSC) 
						Put4bytes(0xC0,&m_buffer[0x45]);
				else
						Put4bytes(0x40,&m_buffer[0x45]);
			}

// Modified 29-Dec-2005: Patch 0x433 and 0x437 (Video presentation times)
			Put4bytes(vobu_s_ptm,&m_buffer[0x433]);
			Put4bytes(vobu_se_e_ptm,&m_buffer[0x437]);

			if (nButtons)
			{
// Modify highligth times
				Put4bytes(vobu_s_ptm,&m_buffer[0x8f]);
				Put4bytes(0xFFFFFFFF,&m_buffer[0x93]);
				Put4bytes(0xFFFFFFFF,&m_buffer[0x97]);
// Modify highlight status
				Put2bytes(         1,&m_buffer[0x8d]);
			}
// Write Nav pack
			ModifyCID (&m_buffer[0],NVID,NCID);
			WritePack(&m_buffer[0],nVTS);
		}

/////////////////////////////////////////////////////////////
// First VOBU 
///////////////////////////////////////////////////////////
		if (bFirstVobu && bAudio)
		{
			scr=readscr(m_buffer); // reads nav scr...
			scr_ext=readscr_ext(m_buffer); // reads nav scr_ext...
			nInserted=0;
			for (j=1, bInserting=true; j<ilastpack+1 ; j++)
			{
				if ((IsAudio(&m_buffer[2048*j]) && bAudio) || 
				    (IsSubs (&m_buffer[2048*j])) )
				{
					i64auxp1++;
					if (bInserting)
					{
						scr_new=readscr(m_buffer+j*2048);

						if (scr_new > scr+146)
							nToBeInserted=(int)((scr_new-scr)/147 -1);
						else nToBeInserted=0;

	// First non-nav MUST be a video
						if (nToBeInserted==0 && nInserted==0) nToBeInserted=1;

						if (nInserted+nToBeInserted >= nPacksIFrame)
						{
							nToBeInserted=nPacksIFrame-nInserted;
							bInserting=false;
						}
						for (i=0; i<nToBeInserted; i++)
						{
							scr+=146;
							scr_ext+=86;
							if (scr_ext > 299) {scr++; scr_ext-=300;}
							writescr(scr,scr_ext, &m_IFrame[2048*(nInserted+i)]);
							if ((nInserted+i)==0)
							// patch video pts/dts
							{
								if (m_IFrame[0x15] & 0x80) 
									writepts(&m_IFrame[0x17],videopts);
								if (m_IFrame[0x15] & 0x40) 
									writepts(&m_IFrame[0x17+5],videodts);
							}
							WritePack(&m_IFrame[2048*(nInserted+i)],nVTS);
						}
						nInserted+=nToBeInserted;
						scr=scr_new;
						scr_ext=readscr_ext(m_buffer+j*2048); // reads next scr_ext...
					}
// patch subs PTS
				    if (IsSubs (&m_buffer[2048*j])) 
					{
						if (m_buffer[2048*j+0x15] & 0x80) 
							writepts(&m_buffer[2048*j+0x17],videopts);
					}

					WritePack(&m_buffer[2048*j],nVTS);
				}
			}
			if (bInserting)
			{
				nToBeInserted=nPacksIFrame-nInserted;
				bInserting=false;
				for (i=0; i<nToBeInserted; i++)
				{
					scr+=146;
					scr_ext+=86;
					if (scr_ext > 299) {scr++; scr_ext-=300;}
					writescr(scr,scr_ext, &m_IFrame[2048*(nInserted+i)]);
					WritePack(&m_IFrame[2048*(nInserted+i)],nVTS);
				}
			}
		}
		if (bSecondVobu) bSecondVobu=false;

		if (bFirstVobu)
		{
			bFirstVobu=false;
			bSecondVobu=true;
		}
		
	}

	delete [] m_IFrame;
	if (m_Fin !=NULL) fclose (m_Fin); 

}
